/* sudoku-cell.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <adwaita.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY,
	SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY,
	SUDOKU_CELL_PAUSED_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SudokuViewPrivate SudokuViewPrivate;
typedef enum  {
	ZOOM_LEVEL_SMALL = 1,
	ZOOM_LEVEL_MEDIUM = 2,
	ZOOM_LEVEL_LARGE = 3
} ZoomLevel;

#define TYPE_ZOOM_LEVEL (zoom_level_get_type ())
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	SudokuView* view;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	gboolean control_key_pressed;
	GtkPopover* popover;
	GtkEventControllerKey* key_controller;
	GtkEventControllerKey* popover_controller;
	NumberPicker* earmark_picker;
	NumberPicker* value_picker;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlight_coord;
	gboolean _highlight_number;
	gboolean _paused;
};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	gboolean earmark_mode;
	gboolean autoclean_earmarks;
	gboolean number_picker_second_click;
	gboolean highlight_row_column;
	gboolean highlight_block;
	gboolean highlight_numbers;
	gdouble value_zoom_multiplier;
	ZoomLevel zoom_level;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
static void sudoku_cell_focus_changed_cb (SudokuCell* self);
static void _sudoku_cell_focus_changed_cb_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void sudoku_cell_set_fixed_css (SudokuCell* self,
                                gboolean enabled);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* gesture,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* gesture,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
VALA_EXTERN NumberPicker* number_picker_new (SudokuGame* game,
                                 gboolean for_earmarks);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuGame* game,
                                       gboolean for_earmarks);
static void sudoku_cell_value_picked_cb (SudokuCell* self,
                                  gint val);
static void _sudoku_cell_value_picked_cb_number_picker_value_picked (NumberPicker* _sender,
                                                              gint val,
                                                              gpointer self);
static void sudoku_cell_earmark_picked_cb (SudokuCell* self,
                                    gint num,
                                    gboolean state);
static void _sudoku_cell_earmark_picked_cb_number_picker_earmark_state_changed (NumberPicker* _sender,
                                                                         gint num,
                                                                         gboolean active,
                                                                         gpointer self);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_get_visible_earmarks (SudokuCell* self);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType zoom_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
VALA_EXTERN gboolean number_picker_get_is_earmark_picker (NumberPicker* self);
VALA_EXTERN void number_picker_set_earmark_button (NumberPicker* self,
                                       gint num,
                                       gboolean state);
static void sudoku_cell_show_value_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
VALA_EXTERN void sudoku_cell_get_visible_earmark (SudokuCell* self,
                                      gint num);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN void number_picker_set_earmark_buttons (NumberPicker* self,
                                        gint row,
                                        gint col);
VALA_EXTERN void number_picker_set_earmark_buttons_sensitive (NumberPicker* self,
                                                  gboolean enabled);
VALA_EXTERN void sudoku_cell_check_value_warnings (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_solution_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_earmarks_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num);
VALA_EXTERN gboolean sudoku_view_get_show_earmark_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel* label,
                                gint font_size);
static void sudoku_cell_real_dispose (GObject* base);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlight_coord (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlight_coord (SudokuCell* self,
                                      gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlight_number (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlight_number (SudokuCell* self,
                                       gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_paused (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_paused (SudokuCell* self,
                             gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 51 "../src/sudoku-cell.vala"
	return self ? g_object_ref (self) : NULL;
#line 323 "sudoku-cell.c"
}

static void
_sudoku_cell_focus_changed_cb_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 61 "../src/sudoku-cell.vala"
	sudoku_cell_focus_changed_cb ((SudokuCell*) self);
#line 333 "sudoku-cell.c"
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 72 "../src/sudoku-cell.vala"
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
#line 344 "sudoku-cell.c"
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 73 "../src/sudoku-cell.vala"
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
#line 356 "sudoku-cell.c"
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
#line 94 "../src/sudoku-cell.vala"
	return result;
#line 370 "sudoku-cell.c"
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
#line 95 "../src/sudoku-cell.vala"
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
#line 382 "sudoku-cell.c"
}

static void
_sudoku_cell_value_picked_cb_number_picker_value_picked (NumberPicker* _sender,
                                                         gint val,
                                                         gpointer self)
{
#line 107 "../src/sudoku-cell.vala"
	sudoku_cell_value_picked_cb ((SudokuCell*) self, val);
#line 392 "sudoku-cell.c"
}

static void
_sudoku_cell_earmark_picked_cb_number_picker_earmark_state_changed (NumberPicker* _sender,
                                                                    gint num,
                                                                    gboolean active,
                                                                    gpointer self)
{
#line 110 "../src/sudoku-cell.vala"
	sudoku_cell_earmark_picked_cb ((SudokuCell*) self, num, active);
#line 403 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame* game,
                       SudokuView* view)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkGestureClick* _tmp13_;
	GtkEventController* _tmp14_;
	GtkGestureLongPress* _tmp15_;
	GtkGestureLongPress* _tmp16_;
	GtkEventController* _tmp17_;
	GtkGestureLongPress* _tmp18_;
	GtkGestureClick* _tmp19_;
	gint num = 0;
	GtkLabel** _tmp20_;
	gboolean _tmp44_;
	gboolean _tmp45_;
#line 45 "../src/sudoku-cell.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 45 "../src/sudoku-cell.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 45 "../src/sudoku-cell.vala"
	self = (SudokuCell*) g_object_new (object_type, NULL);
#line 47 "../src/sudoku-cell.vala"
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
#line 49 "../src/sudoku-cell.vala"
	self->priv->row = row;
#line 50 "../src/sudoku-cell.vala"
	self->priv->col = col;
#line 51 "../src/sudoku-cell.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 51 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 51 "../src/sudoku-cell.vala"
	self->priv->game = _tmp0_;
#line 52 "../src/sudoku-cell.vala"
	self->priv->view = view;
#line 54 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 54 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 54 "../src/sudoku-cell.vala"
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
#line 54 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 54 "../src/sudoku-cell.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 54 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp5_);
#line 54 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 54 "../src/sudoku-cell.vala"
	self->priv->value_label = _tmp5_;
#line 54 "../src/sudoku-cell.vala"
	_g_free0 (_tmp4_);
#line 55 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->value_label;
#line 55 "../src/sudoku-cell.vala"
	_tmp7_ = sudoku_cell_get_value (self);
#line 55 "../src/sudoku-cell.vala"
	_tmp8_ = _tmp7_;
#line 55 "../src/sudoku-cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp8_ != 0);
#line 56 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->value_label;
#line 56 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp9_, (GtkWidget*) self);
#line 57 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->value_label;
#line 57 "../src/sudoku-cell.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp10_, "value");
#line 59 "../src/sudoku-cell.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 60 "../src/sudoku-cell.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 61 "../src/sudoku-cell.vala"
	g_signal_connect_object ((GObject*) self, "notify::has-focus", (GCallback) _sudoku_cell_focus_changed_cb_g_object_notify, self, 0);
#line 63 "../src/sudoku-cell.vala"
	sudoku_cell_set_fixed_css (self, TRUE);
#line 65 "../src/sudoku-cell.vala"
	_tmp11_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 65 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 65 "../src/sudoku-cell.vala"
	self->priv->button_controller = _tmp11_;
#line 66 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->button_controller;
#line 66 "../src/sudoku-cell.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp12_, (guint) 0);
#line 67 "../src/sudoku-cell.vala"
	_tmp13_ = self->priv->button_controller;
#line 67 "../src/sudoku-cell.vala"
	_tmp14_ = _g_object_ref0 ((GtkEventController*) _tmp13_);
#line 67 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp14_);
#line 69 "../src/sudoku-cell.vala"
	_tmp15_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 69 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 69 "../src/sudoku-cell.vala"
	self->priv->long_press_controller = _tmp15_;
#line 70 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->long_press_controller;
#line 70 "../src/sudoku-cell.vala"
	_tmp17_ = _g_object_ref0 ((GtkEventController*) _tmp16_);
#line 70 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp17_);
#line 72 "../src/sudoku-cell.vala"
	_tmp18_ = self->priv->long_press_controller;
#line 72 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp18_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 73 "../src/sudoku-cell.vala"
	_tmp19_ = self->priv->button_controller;
#line 73 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp19_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
#line 75 "../src/sudoku-cell.vala"
	num = 0;
#line 76 "../src/sudoku-cell.vala"
	_tmp20_ = g_new0 (GtkLabel*, 9 + 1);
#line 76 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 76 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = _tmp20_;
#line 76 "../src/sudoku-cell.vala"
	self->priv->earmark_labels_length1 = 9;
#line 76 "../src/sudoku-cell.vala"
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
#line 548 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 77 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 553 "sudoku-cell.c"
		{
			gboolean _tmp21_ = FALSE;
#line 77 "../src/sudoku-cell.vala"
			_tmp21_ = TRUE;
#line 77 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 560 "sudoku-cell.c"
				SudokuBoard* _tmp23_;
				SudokuBoard* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
#line 77 "../src/sudoku-cell.vala"
				if (!_tmp21_) {
#line 567 "sudoku-cell.c"
					gint _tmp22_;
#line 77 "../src/sudoku-cell.vala"
					_tmp22_ = row_tmp;
#line 77 "../src/sudoku-cell.vala"
					row_tmp = _tmp22_ + 1;
#line 573 "sudoku-cell.c"
				}
#line 77 "../src/sudoku-cell.vala"
				_tmp21_ = FALSE;
#line 77 "../src/sudoku-cell.vala"
				_tmp23_ = sudoku_game_get_board (game);
#line 77 "../src/sudoku-cell.vala"
				_tmp24_ = _tmp23_;
#line 77 "../src/sudoku-cell.vala"
				_tmp25_ = sudoku_board_get_block_rows (_tmp24_);
#line 77 "../src/sudoku-cell.vala"
				_tmp26_ = _tmp25_;
#line 77 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp26_)) {
#line 77 "../src/sudoku-cell.vala"
					break;
#line 589 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 79 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 595 "sudoku-cell.c"
					{
						gboolean _tmp27_ = FALSE;
#line 79 "../src/sudoku-cell.vala"
						_tmp27_ = TRUE;
#line 79 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 602 "sudoku-cell.c"
							SudokuBoard* _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							gchar* _tmp35_;
							gchar* _tmp36_;
							GtkLabel* _tmp37_;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							GtkLabel* _tmp39_;
							GtkLabel** _tmp40_;
							gint _tmp40__length1;
							GtkLabel* _tmp41_;
							GtkLabel** _tmp42_;
							gint _tmp42__length1;
							GtkLabel* _tmp43_;
#line 79 "../src/sudoku-cell.vala"
							if (!_tmp27_) {
#line 624 "sudoku-cell.c"
								gint _tmp28_;
#line 79 "../src/sudoku-cell.vala"
								_tmp28_ = col_tmp;
#line 79 "../src/sudoku-cell.vala"
								col_tmp = _tmp28_ + 1;
#line 630 "sudoku-cell.c"
							}
#line 79 "../src/sudoku-cell.vala"
							_tmp27_ = FALSE;
#line 79 "../src/sudoku-cell.vala"
							_tmp29_ = sudoku_game_get_board (game);
#line 79 "../src/sudoku-cell.vala"
							_tmp30_ = _tmp29_;
#line 79 "../src/sudoku-cell.vala"
							_tmp31_ = sudoku_board_get_block_cols (_tmp30_);
#line 79 "../src/sudoku-cell.vala"
							_tmp32_ = _tmp31_;
#line 79 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp32_)) {
#line 79 "../src/sudoku-cell.vala"
								break;
#line 646 "sudoku-cell.c"
							}
#line 81 "../src/sudoku-cell.vala"
							_tmp33_ = num;
#line 81 "../src/sudoku-cell.vala"
							num = _tmp33_ + 1;
#line 83 "../src/sudoku-cell.vala"
							_tmp34_ = self->priv->earmark_labels;
#line 83 "../src/sudoku-cell.vala"
							_tmp34__length1 = self->priv->earmark_labels_length1;
#line 83 "../src/sudoku-cell.vala"
							_tmp35_ = g_strdup_printf ("%i", num);
#line 83 "../src/sudoku-cell.vala"
							_tmp36_ = _tmp35_;
#line 83 "../src/sudoku-cell.vala"
							_tmp37_ = (GtkLabel*) gtk_label_new (_tmp36_);
#line 83 "../src/sudoku-cell.vala"
							g_object_ref_sink (_tmp37_);
#line 83 "../src/sudoku-cell.vala"
							_g_object_unref0 (_tmp34_[num - 1]);
#line 83 "../src/sudoku-cell.vala"
							_tmp34_[num - 1] = _tmp37_;
#line 83 "../src/sudoku-cell.vala"
							_g_free0 (_tmp36_);
#line 84 "../src/sudoku-cell.vala"
							_tmp38_ = self->priv->earmark_labels;
#line 84 "../src/sudoku-cell.vala"
							_tmp38__length1 = self->priv->earmark_labels_length1;
#line 84 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_[num - 1];
#line 84 "../src/sudoku-cell.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
#line 85 "../src/sudoku-cell.vala"
							_tmp40_ = self->priv->earmark_labels;
#line 85 "../src/sudoku-cell.vala"
							_tmp40__length1 = self->priv->earmark_labels_length1;
#line 85 "../src/sudoku-cell.vala"
							_tmp41_ = _tmp40_[num - 1];
#line 85 "../src/sudoku-cell.vala"
							gtk_widget_set_parent ((GtkWidget*) _tmp41_, (GtkWidget*) self);
#line 86 "../src/sudoku-cell.vala"
							_tmp42_ = self->priv->earmark_labels;
#line 86 "../src/sudoku-cell.vala"
							_tmp42__length1 = self->priv->earmark_labels_length1;
#line 86 "../src/sudoku-cell.vala"
							_tmp43_ = _tmp42_[num - 1];
#line 86 "../src/sudoku-cell.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp43_, "earmark");
#line 694 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 90 "../src/sudoku-cell.vala"
	_tmp44_ = sudoku_cell_get_is_fixed (self);
#line 90 "../src/sudoku-cell.vala"
	_tmp45_ = _tmp44_;
#line 90 "../src/sudoku-cell.vala"
	if (!_tmp45_) {
#line 707 "sudoku-cell.c"
		GtkEventControllerKey* _tmp46_;
		GtkEventControllerKey* _tmp47_;
		GtkEventController* _tmp48_;
		GtkEventControllerKey* _tmp49_;
		GtkEventControllerKey* _tmp50_;
		GtkPopover* _tmp51_;
		GtkPopover* _tmp52_;
		GtkPopover* _tmp53_;
		GtkEventControllerKey* _tmp54_;
		GtkEventControllerKey* _tmp55_;
		GtkEventControllerKey* _tmp56_;
		GtkWidget* _tmp57_ = NULL;
		GtkPopover* _tmp58_;
		NumberPicker* _tmp61_;
		NumberPicker* _tmp62_;
		NumberPicker* _tmp63_;
		NumberPicker* _tmp64_;
		NumberPicker* _tmp65_;
#line 92 "../src/sudoku-cell.vala"
		_tmp46_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 92 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->key_controller);
#line 92 "../src/sudoku-cell.vala"
		self->priv->key_controller = _tmp46_;
#line 93 "../src/sudoku-cell.vala"
		_tmp47_ = self->priv->key_controller;
#line 93 "../src/sudoku-cell.vala"
		_tmp48_ = _g_object_ref0 ((GtkEventController*) _tmp47_);
#line 93 "../src/sudoku-cell.vala"
		gtk_widget_add_controller ((GtkWidget*) self, _tmp48_);
#line 94 "../src/sudoku-cell.vala"
		_tmp49_ = self->priv->key_controller;
#line 94 "../src/sudoku-cell.vala"
		g_signal_connect_object (_tmp49_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 95 "../src/sudoku-cell.vala"
		_tmp50_ = self->priv->key_controller;
#line 95 "../src/sudoku-cell.vala"
		g_signal_connect_object (_tmp50_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 97 "../src/sudoku-cell.vala"
		_tmp51_ = (GtkPopover*) gtk_popover_new ();
#line 97 "../src/sudoku-cell.vala"
		g_object_ref_sink (_tmp51_);
#line 97 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->popover);
#line 97 "../src/sudoku-cell.vala"
		self->priv->popover = _tmp51_;
#line 98 "../src/sudoku-cell.vala"
		_tmp52_ = self->priv->popover;
#line 98 "../src/sudoku-cell.vala"
		gtk_popover_set_autohide (_tmp52_, FALSE);
#line 99 "../src/sudoku-cell.vala"
		_tmp53_ = self->priv->popover;
#line 99 "../src/sudoku-cell.vala"
		gtk_widget_set_parent ((GtkWidget*) _tmp53_, (GtkWidget*) self);
#line 101 "../src/sudoku-cell.vala"
		_tmp54_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 101 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->popover_controller);
#line 101 "../src/sudoku-cell.vala"
		self->priv->popover_controller = _tmp54_;
#line 102 "../src/sudoku-cell.vala"
		_tmp55_ = self->priv->popover_controller;
#line 102 "../src/sudoku-cell.vala"
		g_signal_connect_object (_tmp55_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 103 "../src/sudoku-cell.vala"
		_tmp56_ = self->priv->popover_controller;
#line 103 "../src/sudoku-cell.vala"
		g_signal_connect_object (_tmp56_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 104 "../src/sudoku-cell.vala"
		_tmp58_ = self->priv->popover;
#line 104 "../src/sudoku-cell.vala"
		_tmp57_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp58_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp58_) : NULL;
#line 104 "../src/sudoku-cell.vala"
		if (_tmp57_ != NULL) {
#line 782 "sudoku-cell.c"
			GtkEventControllerKey* _tmp59_;
			GtkEventController* _tmp60_;
#line 104 "../src/sudoku-cell.vala"
			_tmp59_ = self->priv->popover_controller;
#line 104 "../src/sudoku-cell.vala"
			_tmp60_ = _g_object_ref0 ((GtkEventController*) _tmp59_);
#line 104 "../src/sudoku-cell.vala"
			gtk_widget_add_controller (_tmp57_, _tmp60_);
#line 791 "sudoku-cell.c"
		}
#line 106 "../src/sudoku-cell.vala"
		_tmp61_ = number_picker_new (game, FALSE);
#line 106 "../src/sudoku-cell.vala"
		g_object_ref_sink (_tmp61_);
#line 106 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->value_picker);
#line 106 "../src/sudoku-cell.vala"
		self->priv->value_picker = _tmp61_;
#line 107 "../src/sudoku-cell.vala"
		_tmp62_ = self->priv->value_picker;
#line 107 "../src/sudoku-cell.vala"
		g_signal_connect_object (_tmp62_, "value-picked", (GCallback) _sudoku_cell_value_picked_cb_number_picker_value_picked, self, 0);
#line 109 "../src/sudoku-cell.vala"
		_tmp63_ = number_picker_new (game, TRUE);
#line 109 "../src/sudoku-cell.vala"
		g_object_ref_sink (_tmp63_);
#line 109 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->earmark_picker);
#line 109 "../src/sudoku-cell.vala"
		self->priv->earmark_picker = _tmp63_;
#line 110 "../src/sudoku-cell.vala"
		_tmp64_ = self->priv->earmark_picker;
#line 110 "../src/sudoku-cell.vala"
		g_signal_connect_object (_tmp64_, "earmark-state-changed", (GCallback) _sudoku_cell_earmark_picked_cb_number_picker_earmark_state_changed, self, 0);
#line 111 "../src/sudoku-cell.vala"
		_tmp65_ = self->priv->earmark_picker;
#line 111 "../src/sudoku-cell.vala"
		g_signal_connect_object (_tmp65_, "value-picked", (GCallback) _sudoku_cell_value_picked_cb_number_picker_value_picked, self, 0);
#line 821 "sudoku-cell.c"
	}
#line 45 "../src/sudoku-cell.vala"
	return self;
#line 825 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame* game,
                 SudokuView* view)
{
#line 45 "../src/sudoku-cell.vala"
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game, view);
#line 836 "sudoku-cell.c"
}

static void
sudoku_cell_set_fixed_css (SudokuCell* self,
                           gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 141 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_is_fixed (self);
#line 143 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 143 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 145 "../src/sudoku-cell.vala"
		if (enabled) {
#line 146 "../src/sudoku-cell.vala"
			gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
#line 857 "sudoku-cell.c"
		} else {
#line 148 "../src/sudoku-cell.vala"
			gtk_widget_remove_css_class ((GtkWidget*) self, "fixed");
#line 861 "sudoku-cell.c"
		}
	}
}

void
sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                   gint val,
                                   gboolean enabled)
{
	GtkLabel* earmark = NULL;
	GtkLabel** _tmp0_;
	gint _tmp0__length1;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 211 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->earmark_labels;
#line 213 "../src/sudoku-cell.vala"
	_tmp0__length1 = self->priv->earmark_labels_length1;
#line 213 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_[val - 1];
#line 213 "../src/sudoku-cell.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 213 "../src/sudoku-cell.vala"
	earmark = _tmp2_;
#line 214 "../src/sudoku-cell.vala"
	if (enabled) {
#line 891 "sudoku-cell.c"
		GtkLabel* _tmp4_;
#line 214 "../src/sudoku-cell.vala"
		_tmp4_ = earmark;
#line 214 "../src/sudoku-cell.vala"
		_tmp3_ = !gtk_widget_has_css_class ((GtkWidget*) _tmp4_, "error");
#line 897 "sudoku-cell.c"
	} else {
#line 214 "../src/sudoku-cell.vala"
		_tmp3_ = FALSE;
#line 901 "sudoku-cell.c"
	}
#line 214 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 905 "sudoku-cell.c"
		GtkLabel* _tmp5_;
#line 215 "../src/sudoku-cell.vala"
		_tmp5_ = earmark;
#line 215 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "highlight-number");
#line 911 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp6_;
#line 217 "../src/sudoku-cell.vala"
		_tmp6_ = earmark;
#line 217 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp6_, "highlight-number");
#line 918 "sudoku-cell.c"
	}
#line 211 "../src/sudoku-cell.vala"
	_g_object_unref0 (earmark);
#line 922 "sudoku-cell.c"
}

void
sudoku_cell_update_value (SudokuCell* self)
{
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 220 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 222 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->value_label;
#line 222 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 222 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 222 "../src/sudoku-cell.vala"
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
#line 222 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 222 "../src/sudoku-cell.vala"
	gtk_label_set_label (_tmp0_, _tmp4_);
#line 222 "../src/sudoku-cell.vala"
	_g_free0 (_tmp4_);
#line 223 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->value_label;
#line 223 "../src/sudoku-cell.vala"
	_tmp6_ = sudoku_cell_get_value (self);
#line 223 "../src/sudoku-cell.vala"
	_tmp7_ = _tmp6_;
#line 223 "../src/sudoku-cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, _tmp7_ != 0);
#line 224 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 962 "sudoku-cell.c"
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 227 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 231 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 231 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 979 "sudoku-cell.c"
	} else {
#line 231 "../src/sudoku-cell.vala"
		_tmp0_ = keyval == GDK_KEY_Control_R;
#line 983 "sudoku-cell.c"
	}
#line 231 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 232 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = TRUE;
#line 989 "sudoku-cell.c"
	}
#line 236 "../src/sudoku-cell.vala"
	result = GDK_EVENT_PROPAGATE;
#line 236 "../src/sudoku-cell.vala"
	return result;
#line 995 "sudoku-cell.c"
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gint key = 0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
#line 239 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 243 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 243 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 243 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 244 "../src/sudoku-cell.vala"
		return;
#line 1026 "sudoku-cell.c"
	}
#line 246 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 246 "../src/sudoku-cell.vala"
		_tmp3_ = TRUE;
#line 1032 "sudoku-cell.c"
	} else {
#line 246 "../src/sudoku-cell.vala"
		_tmp3_ = keyval == GDK_KEY_Control_R;
#line 1036 "sudoku-cell.c"
	}
#line 246 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 247 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = FALSE;
#line 1042 "sudoku-cell.c"
	}
#line 249 "../src/sudoku-cell.vala"
	key = sudoku_cell_get_key_number (self, keyval);
#line 250 "../src/sudoku-cell.vala"
	if (key >= 1) {
#line 250 "../src/sudoku-cell.vala"
		_tmp4_ = key <= 9;
#line 1050 "sudoku-cell.c"
	} else {
#line 250 "../src/sudoku-cell.vala"
		_tmp4_ = FALSE;
#line 1054 "sudoku-cell.c"
	}
#line 250 "../src/sudoku-cell.vala"
	if (_tmp4_) {
#line 1058 "sudoku-cell.c"
		gboolean want_earmark = FALSE;
		SudokuView* _tmp5_;
#line 252 "../src/sudoku-cell.vala"
		want_earmark = self->priv->control_key_pressed;
#line 253 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->view;
#line 253 "../src/sudoku-cell.vala"
		if (_tmp5_->earmark_mode) {
#line 254 "../src/sudoku-cell.vala"
			want_earmark = !want_earmark;
#line 1069 "sudoku-cell.c"
		}
#line 256 "../src/sudoku-cell.vala"
		if (!want_earmark) {
#line 258 "../src/sudoku-cell.vala"
			sudoku_cell_set_value (self, key);
#line 1075 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp6_;
			GameMode _tmp7_;
			GameMode _tmp8_;
#line 260 "../src/sudoku-cell.vala"
			_tmp6_ = self->priv->game;
#line 260 "../src/sudoku-cell.vala"
			_tmp7_ = sudoku_game_get_mode (_tmp6_);
#line 260 "../src/sudoku-cell.vala"
			_tmp8_ = _tmp7_;
#line 260 "../src/sudoku-cell.vala"
			if (_tmp8_ == GAME_MODE_PLAY) {
#line 1088 "sudoku-cell.c"
				gboolean new_state = FALSE;
				SudokuGame* _tmp9_;
				SudokuBoard* _tmp10_;
				SudokuBoard* _tmp11_;
				gboolean _tmp12_ = FALSE;
				GtkPopover* _tmp13_;
				GtkWidget* _tmp14_;
				GtkWidget* _tmp15_;
#line 262 "../src/sudoku-cell.vala"
				_tmp9_ = self->priv->game;
#line 262 "../src/sudoku-cell.vala"
				_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 262 "../src/sudoku-cell.vala"
				_tmp11_ = _tmp10_;
#line 262 "../src/sudoku-cell.vala"
				new_state = !sudoku_board_is_earmark_enabled (_tmp11_, self->priv->row, self->priv->col, key);
#line 263 "../src/sudoku-cell.vala"
				_tmp13_ = self->priv->popover;
#line 263 "../src/sudoku-cell.vala"
				_tmp14_ = gtk_popover_get_child (_tmp13_);
#line 263 "../src/sudoku-cell.vala"
				_tmp15_ = _tmp14_;
#line 263 "../src/sudoku-cell.vala"
				if (_tmp15_ != NULL) {
#line 1113 "sudoku-cell.c"
					GtkPopover* _tmp16_;
					GtkWidget* _tmp17_;
					GtkWidget* _tmp18_;
					gboolean _tmp19_;
					gboolean _tmp20_;
#line 263 "../src/sudoku-cell.vala"
					_tmp16_ = self->priv->popover;
#line 263 "../src/sudoku-cell.vala"
					_tmp17_ = gtk_popover_get_child (_tmp16_);
#line 263 "../src/sudoku-cell.vala"
					_tmp18_ = _tmp17_;
#line 263 "../src/sudoku-cell.vala"
					_tmp19_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_NUMBER_PICKER, NumberPicker));
#line 263 "../src/sudoku-cell.vala"
					_tmp20_ = _tmp19_;
#line 263 "../src/sudoku-cell.vala"
					_tmp12_ = _tmp20_;
#line 1131 "sudoku-cell.c"
				} else {
#line 263 "../src/sudoku-cell.vala"
					_tmp12_ = FALSE;
#line 1135 "sudoku-cell.c"
				}
#line 263 "../src/sudoku-cell.vala"
				if (_tmp12_) {
#line 1139 "sudoku-cell.c"
					NumberPicker* _tmp21_;
#line 265 "../src/sudoku-cell.vala"
					_tmp21_ = self->priv->earmark_picker;
#line 265 "../src/sudoku-cell.vala"
					number_picker_set_earmark_button (_tmp21_, key, new_state);
#line 1145 "sudoku-cell.c"
				} else {
#line 269 "../src/sudoku-cell.vala"
					if (new_state) {
#line 1149 "sudoku-cell.c"
						SudokuGame* _tmp22_;
#line 270 "../src/sudoku-cell.vala"
						_tmp22_ = self->priv->game;
#line 270 "../src/sudoku-cell.vala"
						sudoku_game_enable_earmark (_tmp22_, self->priv->row, self->priv->col, key);
#line 1155 "sudoku-cell.c"
					} else {
						SudokuGame* _tmp23_;
#line 272 "../src/sudoku-cell.vala"
						_tmp23_ = self->priv->game;
#line 272 "../src/sudoku-cell.vala"
						sudoku_game_disable_earmark (_tmp23_, self->priv->row, self->priv->col, key);
#line 1162 "sudoku-cell.c"
					}
				}
			}
		}
#line 275 "../src/sudoku-cell.vala"
		return;
#line 1169 "sudoku-cell.c"
	}
#line 278 "../src/sudoku-cell.vala"
	if (key == 0) {
#line 278 "../src/sudoku-cell.vala"
		_tmp25_ = TRUE;
#line 1175 "sudoku-cell.c"
	} else {
#line 279 "../src/sudoku-cell.vala"
		_tmp25_ = keyval == GDK_KEY_BackSpace;
#line 1179 "sudoku-cell.c"
	}
#line 278 "../src/sudoku-cell.vala"
	if (_tmp25_) {
#line 278 "../src/sudoku-cell.vala"
		_tmp24_ = TRUE;
#line 1185 "sudoku-cell.c"
	} else {
#line 280 "../src/sudoku-cell.vala"
		_tmp24_ = keyval == GDK_KEY_Delete;
#line 1189 "sudoku-cell.c"
	}
#line 278 "../src/sudoku-cell.vala"
	if (_tmp24_) {
#line 282 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, 0);
#line 283 "../src/sudoku-cell.vala"
		return;
#line 1197 "sudoku-cell.c"
	}
#line 286 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_space) {
#line 286 "../src/sudoku-cell.vala"
		_tmp27_ = TRUE;
#line 1203 "sudoku-cell.c"
	} else {
#line 287 "../src/sudoku-cell.vala"
		_tmp27_ = keyval == GDK_KEY_Return;
#line 1207 "sudoku-cell.c"
	}
#line 286 "../src/sudoku-cell.vala"
	if (_tmp27_) {
#line 286 "../src/sudoku-cell.vala"
		_tmp26_ = TRUE;
#line 1213 "sudoku-cell.c"
	} else {
#line 288 "../src/sudoku-cell.vala"
		_tmp26_ = keyval == GDK_KEY_KP_Enter;
#line 1217 "sudoku-cell.c"
	}
#line 286 "../src/sudoku-cell.vala"
	if (_tmp26_) {
#line 1221 "sudoku-cell.c"
		SudokuView* _tmp28_;
#line 290 "../src/sudoku-cell.vala"
		_tmp28_ = self->priv->view;
#line 290 "../src/sudoku-cell.vala"
		if (!_tmp28_->earmark_mode) {
#line 291 "../src/sudoku-cell.vala"
			sudoku_cell_show_value_picker (self);
#line 1229 "sudoku-cell.c"
		} else {
			gint _tmp29_;
			gint _tmp30_;
#line 292 "../src/sudoku-cell.vala"
			_tmp29_ = sudoku_cell_get_value (self);
#line 292 "../src/sudoku-cell.vala"
			_tmp30_ = _tmp29_;
#line 292 "../src/sudoku-cell.vala"
			if (_tmp30_ == 0) {
#line 293 "../src/sudoku-cell.vala"
				sudoku_cell_show_earmark_picker (self);
#line 1241 "sudoku-cell.c"
			}
		}
#line 294 "../src/sudoku-cell.vala"
		return;
#line 1246 "sudoku-cell.c"
	}
#line 297 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Escape) {
#line 1250 "sudoku-cell.c"
		GtkPopover* _tmp31_;
		gboolean _tmp32_;
		gboolean _tmp33_;
#line 299 "../src/sudoku-cell.vala"
		_tmp31_ = self->priv->popover;
#line 299 "../src/sudoku-cell.vala"
		_tmp32_ = gtk_widget_get_visible ((GtkWidget*) _tmp31_);
#line 299 "../src/sudoku-cell.vala"
		_tmp33_ = _tmp32_;
#line 299 "../src/sudoku-cell.vala"
		if (_tmp33_) {
#line 1262 "sudoku-cell.c"
			GtkPopover* _tmp34_;
#line 300 "../src/sudoku-cell.vala"
			_tmp34_ = self->priv->popover;
#line 300 "../src/sudoku-cell.vala"
			gtk_popover_popdown (_tmp34_);
#line 1268 "sudoku-cell.c"
		}
#line 301 "../src/sudoku-cell.vala"
		return;
#line 1272 "sudoku-cell.c"
	}
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* gesture,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	SudokuView* _tmp4_;
	gboolean want_earmark = FALSE;
	SudokuView* _tmp12_;
#line 305 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 310 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 311 "../src/sudoku-cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 1298 "sudoku-cell.c"
	} else {
#line 310 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1302 "sudoku-cell.c"
	}
#line 310 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 312 "../src/sudoku-cell.vala"
		return;
#line 1308 "sudoku-cell.c"
	}
#line 314 "../src/sudoku-cell.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 316 "../src/sudoku-cell.vala"
	_tmp4_ = self->priv->view;
#line 316 "../src/sudoku-cell.vala"
	if (_tmp4_->number_picker_second_click) {
#line 1316 "sudoku-cell.c"
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 316 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_selected (self);
#line 316 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 316 "../src/sudoku-cell.vala"
		_tmp3_ = !_tmp6_;
#line 1325 "sudoku-cell.c"
	} else {
#line 316 "../src/sudoku-cell.vala"
		_tmp3_ = FALSE;
#line 1329 "sudoku-cell.c"
	}
#line 316 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 316 "../src/sudoku-cell.vala"
		_tmp2_ = TRUE;
#line 1335 "sudoku-cell.c"
	} else {
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 317 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_cell_get_is_fixed (self);
#line 317 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 317 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp8_;
#line 1345 "sudoku-cell.c"
	}
#line 316 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 316 "../src/sudoku-cell.vala"
		_tmp1_ = TRUE;
#line 1351 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 317 "../src/sudoku-cell.vala"
		_tmp9_ = self->priv->game;
#line 317 "../src/sudoku-cell.vala"
		_tmp10_ = sudoku_game_get_paused (_tmp9_);
#line 317 "../src/sudoku-cell.vala"
		_tmp11_ = _tmp10_;
#line 317 "../src/sudoku-cell.vala"
		_tmp1_ = _tmp11_;
#line 1364 "sudoku-cell.c"
	}
#line 316 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 319 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 320 "../src/sudoku-cell.vala"
		return;
#line 1372 "sudoku-cell.c"
	}
#line 323 "../src/sudoku-cell.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 325 "../src/sudoku-cell.vala"
	want_earmark = self->priv->control_key_pressed;
#line 326 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->view;
#line 326 "../src/sudoku-cell.vala"
	if (_tmp12_->earmark_mode) {
#line 327 "../src/sudoku-cell.vala"
		want_earmark = !want_earmark;
#line 1384 "sudoku-cell.c"
	}
#line 329 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 331 "../src/sudoku-cell.vala"
		if (!want_earmark) {
#line 332 "../src/sudoku-cell.vala"
			sudoku_cell_show_value_picker (self);
#line 1392 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp13_;
			GameMode _tmp14_;
			GameMode _tmp15_;
#line 333 "../src/sudoku-cell.vala"
			_tmp13_ = self->priv->game;
#line 333 "../src/sudoku-cell.vala"
			_tmp14_ = sudoku_game_get_mode (_tmp13_);
#line 333 "../src/sudoku-cell.vala"
			_tmp15_ = _tmp14_;
#line 333 "../src/sudoku-cell.vala"
			if (_tmp15_ == GAME_MODE_PLAY) {
#line 334 "../src/sudoku-cell.vala"
				sudoku_cell_show_earmark_picker (self);
#line 1407 "sudoku-cell.c"
			}
		}
	} else {
#line 336 "../src/sudoku-cell.vala"
		if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY)) {
#line 338 "../src/sudoku-cell.vala"
			if (want_earmark) {
#line 339 "../src/sudoku-cell.vala"
				sudoku_cell_show_value_picker (self);
#line 1417 "sudoku-cell.c"
			} else {
				SudokuGame* _tmp16_;
				GameMode _tmp17_;
				GameMode _tmp18_;
#line 340 "../src/sudoku-cell.vala"
				_tmp16_ = self->priv->game;
#line 340 "../src/sudoku-cell.vala"
				_tmp17_ = sudoku_game_get_mode (_tmp16_);
#line 340 "../src/sudoku-cell.vala"
				_tmp18_ = _tmp17_;
#line 340 "../src/sudoku-cell.vala"
				if (_tmp18_ == GAME_MODE_PLAY) {
#line 341 "../src/sudoku-cell.vala"
					sudoku_cell_show_earmark_picker (self);
#line 1432 "sudoku-cell.c"
				}
			}
		}
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* gesture,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp6_ = FALSE;
	SudokuGame* _tmp7_;
	GameMode _tmp8_;
	GameMode _tmp9_;
#line 345 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 345 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 349 "../src/sudoku-cell.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 350 "../src/sudoku-cell.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 352 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_is_fixed (self);
#line 352 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 352 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 352 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 1468 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 352 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->game;
#line 352 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_game_get_paused (_tmp3_);
#line 352 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 352 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_;
#line 1481 "sudoku-cell.c"
	}
#line 352 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 353 "../src/sudoku-cell.vala"
		return;
#line 1487 "sudoku-cell.c"
	}
#line 355 "../src/sudoku-cell.vala"
	_tmp7_ = self->priv->game;
#line 355 "../src/sudoku-cell.vala"
	_tmp8_ = sudoku_game_get_mode (_tmp7_);
#line 355 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_;
#line 355 "../src/sudoku-cell.vala"
	if (_tmp9_ == GAME_MODE_CREATE) {
#line 355 "../src/sudoku-cell.vala"
		_tmp6_ = TRUE;
#line 1499 "sudoku-cell.c"
	} else {
		SudokuView* _tmp10_;
#line 355 "../src/sudoku-cell.vala"
		_tmp10_ = self->priv->view;
#line 355 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp10_->earmark_mode;
#line 1506 "sudoku-cell.c"
	}
#line 355 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 356 "../src/sudoku-cell.vala"
		sudoku_cell_show_value_picker (self);
#line 1512 "sudoku-cell.c"
	} else {
		gint _tmp11_;
		gint _tmp12_;
#line 357 "../src/sudoku-cell.vala"
		_tmp11_ = sudoku_cell_get_value (self);
#line 357 "../src/sudoku-cell.vala"
		_tmp12_ = _tmp11_;
#line 357 "../src/sudoku-cell.vala"
		if (_tmp12_ == 0) {
#line 358 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1524 "sudoku-cell.c"
		}
	}
}

static void
sudoku_cell_focus_changed_cb (SudokuCell* self)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 361 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 363 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 363 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 363 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 363 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 364 "../src/sudoku-cell.vala"
		return;
#line 1549 "sudoku-cell.c"
	}
#line 366 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp3_, NULL);
#line 366 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 366 "../src/sudoku-cell.vala"
	if (_tmp4_) {
#line 1557 "sudoku-cell.c"
		SudokuView* _tmp5_;
#line 367 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->view;
#line 367 "../src/sudoku-cell.vala"
		sudoku_view_set_selected (_tmp5_, self->priv->row, self->priv->col);
#line 1563 "sudoku-cell.c"
	}
}

static void
sudoku_cell_value_picked_cb (SudokuCell* self,
                             gint val)
{
#line 370 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 372 "../src/sudoku-cell.vala"
	if (val > 0) {
#line 1575 "sudoku-cell.c"
		GtkPopover* _tmp0_;
#line 373 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->popover;
#line 373 "../src/sudoku-cell.vala"
		gtk_popover_popdown (_tmp0_);
#line 1581 "sudoku-cell.c"
	} else {
		NumberPicker* _tmp1_;
#line 375 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->value_picker;
#line 375 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_visibility (_tmp1_, FALSE);
#line 1588 "sudoku-cell.c"
	}
#line 377 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, val);
#line 1592 "sudoku-cell.c"
}

static void
sudoku_cell_earmark_picked_cb (SudokuCell* self,
                               gint num,
                               gboolean state)
{
	NumberPicker* _tmp8_;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	SudokuBoard* _tmp11_;
#line 380 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/sudoku-cell.vala"
	if (state) {
#line 1608 "sudoku-cell.c"
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		SudokuBoard* _tmp2_;
#line 384 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->game;
#line 384 "../src/sudoku-cell.vala"
		_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 384 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp1_;
#line 384 "../src/sudoku-cell.vala"
		if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, num)) {
#line 1620 "sudoku-cell.c"
			SudokuGame* _tmp3_;
#line 385 "../src/sudoku-cell.vala"
			_tmp3_ = self->priv->game;
#line 385 "../src/sudoku-cell.vala"
			sudoku_game_enable_earmark (_tmp3_, self->priv->row, self->priv->col, num);
#line 1626 "sudoku-cell.c"
		}
	} else {
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
		SudokuBoard* _tmp6_;
#line 387 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->game;
#line 387 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 387 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 387 "../src/sudoku-cell.vala"
		if (sudoku_board_is_earmark_enabled (_tmp6_, self->priv->row, self->priv->col, num)) {
#line 1640 "sudoku-cell.c"
			SudokuGame* _tmp7_;
#line 389 "../src/sudoku-cell.vala"
			_tmp7_ = self->priv->game;
#line 389 "../src/sudoku-cell.vala"
			sudoku_game_disable_earmark (_tmp7_, self->priv->row, self->priv->col, num);
#line 1646 "sudoku-cell.c"
		}
	}
#line 392 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->earmark_picker;
#line 392 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->game;
#line 392 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 392 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 392 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_enabled (_tmp8_, sudoku_board_has_earmarks (_tmp11_, self->priv->row, self->priv->col));
#line 1659 "sudoku-cell.c"
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
#line 395 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 397 "../src/sudoku-cell.vala"
	switch (keyval) {
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_0:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_0:
#line 1675 "sudoku-cell.c"
		{
#line 401 "../src/sudoku-cell.vala"
			result = 0;
#line 401 "../src/sudoku-cell.vala"
			return result;
#line 1681 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_1:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_1:
#line 1687 "sudoku-cell.c"
		{
#line 404 "../src/sudoku-cell.vala"
			result = 1;
#line 404 "../src/sudoku-cell.vala"
			return result;
#line 1693 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_2:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_2:
#line 1699 "sudoku-cell.c"
		{
#line 407 "../src/sudoku-cell.vala"
			result = 2;
#line 407 "../src/sudoku-cell.vala"
			return result;
#line 1705 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_3:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_3:
#line 1711 "sudoku-cell.c"
		{
#line 410 "../src/sudoku-cell.vala"
			result = 3;
#line 410 "../src/sudoku-cell.vala"
			return result;
#line 1717 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_4:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_4:
#line 1723 "sudoku-cell.c"
		{
#line 413 "../src/sudoku-cell.vala"
			result = 4;
#line 413 "../src/sudoku-cell.vala"
			return result;
#line 1729 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_5:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_5:
#line 1735 "sudoku-cell.c"
		{
#line 416 "../src/sudoku-cell.vala"
			result = 5;
#line 416 "../src/sudoku-cell.vala"
			return result;
#line 1741 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_6:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_6:
#line 1747 "sudoku-cell.c"
		{
#line 419 "../src/sudoku-cell.vala"
			result = 6;
#line 419 "../src/sudoku-cell.vala"
			return result;
#line 1753 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_7:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_7:
#line 1759 "sudoku-cell.c"
		{
#line 422 "../src/sudoku-cell.vala"
			result = 7;
#line 422 "../src/sudoku-cell.vala"
			return result;
#line 1765 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_8:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_8:
#line 1771 "sudoku-cell.c"
		{
#line 425 "../src/sudoku-cell.vala"
			result = 8;
#line 425 "../src/sudoku-cell.vala"
			return result;
#line 1777 "sudoku-cell.c"
		}
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_9:
#line 397 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_9:
#line 1783 "sudoku-cell.c"
		{
#line 428 "../src/sudoku-cell.vala"
			result = 9;
#line 428 "../src/sudoku-cell.vala"
			return result;
#line 1789 "sudoku-cell.c"
		}
		default:
		{
#line 430 "../src/sudoku-cell.vala"
			result = -1;
#line 430 "../src/sudoku-cell.vala"
			return result;
#line 1797 "sudoku-cell.c"
		}
	}
}

void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
#line 434 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 1807 "sudoku-cell.c"
	{
		gint num = 0;
#line 436 "../src/sudoku-cell.vala"
		num = 1;
#line 1812 "sudoku-cell.c"
		{
			gboolean _tmp0_ = FALSE;
#line 436 "../src/sudoku-cell.vala"
			_tmp0_ = TRUE;
#line 436 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 436 "../src/sudoku-cell.vala"
				if (!_tmp0_) {
#line 1821 "sudoku-cell.c"
					gint _tmp1_;
#line 436 "../src/sudoku-cell.vala"
					_tmp1_ = num;
#line 436 "../src/sudoku-cell.vala"
					num = _tmp1_ + 1;
#line 1827 "sudoku-cell.c"
				}
#line 436 "../src/sudoku-cell.vala"
				_tmp0_ = FALSE;
#line 436 "../src/sudoku-cell.vala"
				if (!(num <= 9)) {
#line 436 "../src/sudoku-cell.vala"
					break;
#line 1835 "sudoku-cell.c"
				}
#line 437 "../src/sudoku-cell.vala"
				sudoku_cell_get_visible_earmark (self, num);
#line 1839 "sudoku-cell.c"
			}
		}
	}
}

void
sudoku_cell_get_visible_earmark (SudokuCell* self,
                                 gint num)
{
	gint _tmp0_;
	gint _tmp1_;
#line 440 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 442 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 442 "../src/sudoku-cell.vala"
	if (_tmp1_ != 0) {
#line 1859 "sudoku-cell.c"
		GtkLabel** _tmp2_;
		gint _tmp2__length1;
		GtkLabel* _tmp3_;
#line 443 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->earmark_labels;
#line 443 "../src/sudoku-cell.vala"
		_tmp2__length1 = self->priv->earmark_labels_length1;
#line 443 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp2_[num - 1];
#line 443 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 1871 "sudoku-cell.c"
	} else {
		GtkLabel** _tmp4_;
		gint _tmp4__length1;
		GtkLabel* _tmp5_;
		SudokuGame* _tmp6_;
		SudokuBoard* _tmp7_;
		SudokuBoard* _tmp8_;
#line 445 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->earmark_labels;
#line 445 "../src/sudoku-cell.vala"
		_tmp4__length1 = self->priv->earmark_labels_length1;
#line 445 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_[num - 1];
#line 445 "../src/sudoku-cell.vala"
		_tmp6_ = self->priv->game;
#line 445 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_game_get_board (_tmp6_);
#line 445 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 445 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, sudoku_board_is_earmark_enabled (_tmp8_, self->priv->row, self->priv->col, num));
#line 1893 "sudoku-cell.c"
	}
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	NumberPicker* _tmp8_;
	NumberPicker* _tmp9_;
	NumberPicker* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_ = FALSE;
	gint _tmp14_;
	gint _tmp15_;
	gboolean clear_button_enabled = FALSE;
	NumberPicker* _tmp19_;
	GtkPopover* _tmp20_;
	NumberPicker* _tmp21_;
	GtkPopover* _tmp22_;
#line 448 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 450 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->popover;
#line 450 "../src/sudoku-cell.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 450 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 450 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 1926 "sudoku-cell.c"
		gboolean is_earmark_picker = FALSE;
		GtkPopover* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 452 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->popover;
#line 452 "../src/sudoku-cell.vala"
		_tmp4_ = gtk_popover_get_child (_tmp3_);
#line 452 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 452 "../src/sudoku-cell.vala"
		_tmp6_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_NUMBER_PICKER, NumberPicker));
#line 452 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 452 "../src/sudoku-cell.vala"
		is_earmark_picker = _tmp7_;
#line 453 "../src/sudoku-cell.vala"
		sudoku_cell_dismiss_popover (self);
#line 454 "../src/sudoku-cell.vala"
		if (is_earmark_picker) {
#line 455 "../src/sudoku-cell.vala"
			return;
#line 1951 "sudoku-cell.c"
		}
	}
#line 458 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->earmark_picker;
#line 458 "../src/sudoku-cell.vala"
	number_picker_set_earmark_buttons (_tmp8_, self->priv->row, self->priv->col);
#line 459 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->earmark_picker;
#line 459 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp9_, TRUE);
#line 460 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->earmark_picker;
#line 460 "../src/sudoku-cell.vala"
	_tmp11_ = sudoku_cell_get_value (self);
#line 460 "../src/sudoku-cell.vala"
	_tmp12_ = _tmp11_;
#line 460 "../src/sudoku-cell.vala"
	number_picker_set_earmark_buttons_sensitive (_tmp10_, _tmp12_ == 0);
#line 461 "../src/sudoku-cell.vala"
	_tmp14_ = sudoku_cell_get_value (self);
#line 461 "../src/sudoku-cell.vala"
	_tmp15_ = _tmp14_;
#line 461 "../src/sudoku-cell.vala"
	if (_tmp15_ != 0) {
#line 461 "../src/sudoku-cell.vala"
		_tmp13_ = TRUE;
#line 1978 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp16_;
		SudokuBoard* _tmp17_;
		SudokuBoard* _tmp18_;
#line 461 "../src/sudoku-cell.vala"
		_tmp16_ = self->priv->game;
#line 461 "../src/sudoku-cell.vala"
		_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 461 "../src/sudoku-cell.vala"
		_tmp18_ = _tmp17_;
#line 461 "../src/sudoku-cell.vala"
		_tmp13_ = sudoku_board_has_earmarks (_tmp18_, self->priv->row, self->priv->col);
#line 1991 "sudoku-cell.c"
	}
#line 461 "../src/sudoku-cell.vala"
	clear_button_enabled = _tmp13_;
#line 462 "../src/sudoku-cell.vala"
	_tmp19_ = self->priv->earmark_picker;
#line 462 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_enabled (_tmp19_, clear_button_enabled);
#line 464 "../src/sudoku-cell.vala"
	_tmp20_ = self->priv->popover;
#line 464 "../src/sudoku-cell.vala"
	_tmp21_ = self->priv->earmark_picker;
#line 464 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp20_, (GtkWidget*) _tmp21_);
#line 465 "../src/sudoku-cell.vala"
	_tmp22_ = self->priv->popover;
#line 465 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp22_);
#line 2009 "sudoku-cell.c"
}

static void
sudoku_cell_show_value_picker (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp10_;
	NumberPicker* _tmp14_;
	GtkPopover* _tmp15_;
	NumberPicker* _tmp16_;
	GtkPopover* _tmp17_;
#line 468 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 470 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->popover;
#line 470 "../src/sudoku-cell.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 470 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 470 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 2035 "sudoku-cell.c"
		gboolean is_earmark_picker = FALSE;
		GtkPopover* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 472 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->popover;
#line 472 "../src/sudoku-cell.vala"
		_tmp4_ = gtk_popover_get_child (_tmp3_);
#line 472 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 472 "../src/sudoku-cell.vala"
		_tmp6_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_NUMBER_PICKER, NumberPicker));
#line 472 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 472 "../src/sudoku-cell.vala"
		is_earmark_picker = _tmp7_;
#line 473 "../src/sudoku-cell.vala"
		sudoku_cell_dismiss_popover (self);
#line 474 "../src/sudoku-cell.vala"
		if (!is_earmark_picker) {
#line 475 "../src/sudoku-cell.vala"
			return;
#line 2060 "sudoku-cell.c"
		}
	}
#line 478 "../src/sudoku-cell.vala"
	_tmp9_ = sudoku_cell_get_value (self);
#line 478 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_;
#line 478 "../src/sudoku-cell.vala"
	if (_tmp10_ > 0) {
#line 478 "../src/sudoku-cell.vala"
		_tmp8_ = TRUE;
#line 2071 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp11_;
		SudokuBoard* _tmp12_;
		SudokuBoard* _tmp13_;
#line 478 "../src/sudoku-cell.vala"
		_tmp11_ = self->priv->game;
#line 478 "../src/sudoku-cell.vala"
		_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 478 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 478 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_board_has_earmarks (_tmp13_, self->priv->row, self->priv->col);
#line 2084 "sudoku-cell.c"
	}
#line 478 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->value_picker;
#line 478 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp14_, _tmp8_);
#line 480 "../src/sudoku-cell.vala"
	_tmp15_ = self->priv->popover;
#line 480 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->value_picker;
#line 480 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp15_, (GtkWidget*) _tmp16_);
#line 481 "../src/sudoku-cell.vala"
	_tmp17_ = self->priv->popover;
#line 481 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp17_);
#line 2100 "sudoku-cell.c"
}

void
sudoku_cell_check_value_warnings (SudokuCell* self)
{
	gboolean _error_ = FALSE;
	gint _tmp0_;
	gint _tmp1_;
#line 484 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 486 "../src/sudoku-cell.vala"
	_error_ = FALSE;
#line 488 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 488 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 488 "../src/sudoku-cell.vala"
	if (_tmp1_ != 0) {
#line 2119 "sudoku-cell.c"
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		Coord _tmp7_ = {0};
#line 490 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->game;
#line 490 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 490 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 490 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_board_get_broken_coords (_tmp4_);
#line 490 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 490 "../src/sudoku-cell.vala"
		coord_init (&_tmp7_, self->priv->row, self->priv->col);
#line 490 "../src/sudoku-cell.vala"
		if (gee_collection_contains ((GeeCollection*) _tmp6_, &_tmp7_)) {
#line 491 "../src/sudoku-cell.vala"
			_error_ = TRUE;
#line 2142 "sudoku-cell.c"
		} else {
			gboolean _tmp8_ = FALSE;
			SudokuView* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 493 "../src/sudoku-cell.vala"
			_tmp9_ = self->priv->view;
#line 493 "../src/sudoku-cell.vala"
			_tmp10_ = sudoku_view_get_solution_warnings (_tmp9_);
#line 493 "../src/sudoku-cell.vala"
			_tmp11_ = _tmp10_;
#line 493 "../src/sudoku-cell.vala"
			if (_tmp11_) {
#line 2156 "sudoku-cell.c"
				SudokuGame* _tmp12_;
				GameMode _tmp13_;
				GameMode _tmp14_;
#line 493 "../src/sudoku-cell.vala"
				_tmp12_ = self->priv->game;
#line 493 "../src/sudoku-cell.vala"
				_tmp13_ = sudoku_game_get_mode (_tmp12_);
#line 493 "../src/sudoku-cell.vala"
				_tmp14_ = _tmp13_;
#line 493 "../src/sudoku-cell.vala"
				_tmp8_ = _tmp14_ == GAME_MODE_PLAY;
#line 2168 "sudoku-cell.c"
			} else {
#line 493 "../src/sudoku-cell.vala"
				_tmp8_ = FALSE;
#line 2172 "sudoku-cell.c"
			}
#line 493 "../src/sudoku-cell.vala"
			if (_tmp8_) {
#line 2176 "sudoku-cell.c"
				gint solution = 0;
				SudokuGame* _tmp15_;
				SudokuBoard* _tmp16_;
				SudokuBoard* _tmp17_;
#line 495 "../src/sudoku-cell.vala"
				_tmp15_ = self->priv->game;
#line 495 "../src/sudoku-cell.vala"
				_tmp16_ = sudoku_game_get_board (_tmp15_);
#line 495 "../src/sudoku-cell.vala"
				_tmp17_ = _tmp16_;
#line 495 "../src/sudoku-cell.vala"
				solution = sudoku_board_get_solution (_tmp17_, self->priv->row, self->priv->col);
#line 496 "../src/sudoku-cell.vala"
				if (solution != 0) {
#line 2191 "sudoku-cell.c"
					gint _tmp18_;
					gint _tmp19_;
#line 497 "../src/sudoku-cell.vala"
					_tmp18_ = sudoku_cell_get_value (self);
#line 497 "../src/sudoku-cell.vala"
					_tmp19_ = _tmp18_;
#line 497 "../src/sudoku-cell.vala"
					_error_ = _tmp19_ != solution;
#line 2200 "sudoku-cell.c"
				}
			}
		}
	}
#line 501 "../src/sudoku-cell.vala"
	if (_error_) {
#line 2207 "sudoku-cell.c"
		GtkLabel* _tmp20_;
#line 502 "../src/sudoku-cell.vala"
		_tmp20_ = self->priv->value_label;
#line 502 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp20_, "error");
#line 2213 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp21_;
#line 504 "../src/sudoku-cell.vala"
		_tmp21_ = self->priv->value_label;
#line 504 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp21_, "error");
#line 2220 "sudoku-cell.c"
	}
}

void
sudoku_cell_check_earmarks_warnings (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean* marks = NULL;
	SudokuGame* _tmp6_;
	SudokuBoard* _tmp7_;
	SudokuBoard* _tmp8_;
	gint _tmp9_ = 0;
	gboolean* _tmp10_;
	gint marks_length1;
	gint _marks_size_;
#line 507 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 509 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 509 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 509 "../src/sudoku-cell.vala"
	if (_tmp2_ != 0) {
#line 509 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 2248 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 509 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->game;
#line 509 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 509 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 509 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_ == GAME_MODE_CREATE;
#line 2261 "sudoku-cell.c"
	}
#line 509 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 510 "../src/sudoku-cell.vala"
		return;
#line 2267 "sudoku-cell.c"
	}
#line 512 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->game;
#line 512 "../src/sudoku-cell.vala"
	_tmp7_ = sudoku_game_get_board (_tmp6_);
#line 512 "../src/sudoku-cell.vala"
	_tmp8_ = _tmp7_;
#line 512 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_board_get_earmarks (_tmp8_, self->priv->row, self->priv->col, &_tmp9_);
#line 512 "../src/sudoku-cell.vala"
	marks = _tmp10_;
#line 512 "../src/sudoku-cell.vala"
	marks_length1 = _tmp9_;
#line 512 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 2283 "sudoku-cell.c"
	{
		gint num = 0;
#line 513 "../src/sudoku-cell.vala"
		num = 1;
#line 2288 "sudoku-cell.c"
		{
			gboolean _tmp11_ = FALSE;
#line 513 "../src/sudoku-cell.vala"
			_tmp11_ = TRUE;
#line 513 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2295 "sudoku-cell.c"
				gboolean* _tmp13_;
				gint _tmp13__length1;
				gboolean* _tmp14_;
				gint _tmp14__length1;
				gboolean _tmp15_;
#line 513 "../src/sudoku-cell.vala"
				if (!_tmp11_) {
#line 2303 "sudoku-cell.c"
					gint _tmp12_;
#line 513 "../src/sudoku-cell.vala"
					_tmp12_ = num;
#line 513 "../src/sudoku-cell.vala"
					num = _tmp12_ + 1;
#line 2309 "sudoku-cell.c"
				}
#line 513 "../src/sudoku-cell.vala"
				_tmp11_ = FALSE;
#line 513 "../src/sudoku-cell.vala"
				_tmp13_ = marks;
#line 513 "../src/sudoku-cell.vala"
				_tmp13__length1 = marks_length1;
#line 513 "../src/sudoku-cell.vala"
				if (!(num <= _tmp13__length1)) {
#line 513 "../src/sudoku-cell.vala"
					break;
#line 2321 "sudoku-cell.c"
				}
#line 515 "../src/sudoku-cell.vala"
				_tmp14_ = marks;
#line 515 "../src/sudoku-cell.vala"
				_tmp14__length1 = marks_length1;
#line 515 "../src/sudoku-cell.vala"
				_tmp15_ = _tmp14_[num - 1];
#line 515 "../src/sudoku-cell.vala"
				if (_tmp15_) {
#line 516 "../src/sudoku-cell.vala"
					sudoku_cell_check_earmark_warnings (self, num);
#line 2333 "sudoku-cell.c"
				}
			}
		}
	}
#line 507 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2340 "sudoku-cell.c"
}

void
sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                    gint num)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuBoard* _tmp3_;
#line 520 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 522 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 522 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_game_get_board (_tmp1_);
#line 522 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 522 "../src/sudoku-cell.vala"
	if (!sudoku_board_is_possible (_tmp3_, self->priv->row, self->priv->col, num)) {
#line 2361 "sudoku-cell.c"
		SudokuView* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 522 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->view;
#line 522 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_view_get_show_earmark_warnings (_tmp4_);
#line 522 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 522 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp6_;
#line 2373 "sudoku-cell.c"
	} else {
#line 522 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 2377 "sudoku-cell.c"
	}
#line 522 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 2381 "sudoku-cell.c"
		GtkLabel** _tmp7_;
		gint _tmp7__length1;
		GtkLabel* _tmp8_;
#line 523 "../src/sudoku-cell.vala"
		_tmp7_ = self->priv->earmark_labels;
#line 523 "../src/sudoku-cell.vala"
		_tmp7__length1 = self->priv->earmark_labels_length1;
#line 523 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_[num - 1];
#line 523 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "error");
#line 2393 "sudoku-cell.c"
	} else {
		GtkLabel** _tmp9_;
		gint _tmp9__length1;
		GtkLabel* _tmp10_;
#line 525 "../src/sudoku-cell.vala"
		_tmp9_ = self->priv->earmark_labels;
#line 525 "../src/sudoku-cell.vala"
		_tmp9__length1 = self->priv->earmark_labels_length1;
#line 525 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_[num - 1];
#line 525 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp10_, "error");
#line 2406 "sudoku-cell.c"
	}
}

void
sudoku_cell_clear_warnings (SudokuCell* self)
{
	gboolean* marks = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_ = 0;
	gboolean* _tmp4_;
	gint marks_length1;
	gint _marks_size_;
	GtkLabel* _tmp5_;
#line 528 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 530 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 530 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 530 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 530 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_board_get_earmarks (_tmp2_, self->priv->row, self->priv->col, &_tmp3_);
#line 530 "../src/sudoku-cell.vala"
	marks = _tmp4_;
#line 530 "../src/sudoku-cell.vala"
	marks_length1 = _tmp3_;
#line 530 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 531 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->value_label;
#line 531 "../src/sudoku-cell.vala"
	gtk_widget_remove_css_class ((GtkWidget*) _tmp5_, "error");
#line 2442 "sudoku-cell.c"
	{
		gint num = 0;
#line 532 "../src/sudoku-cell.vala"
		num = 1;
#line 2447 "sudoku-cell.c"
		{
			gboolean _tmp6_ = FALSE;
#line 532 "../src/sudoku-cell.vala"
			_tmp6_ = TRUE;
#line 532 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2454 "sudoku-cell.c"
				gboolean* _tmp8_;
				gint _tmp8__length1;
				GtkLabel** _tmp9_;
				gint _tmp9__length1;
				GtkLabel* _tmp10_;
#line 532 "../src/sudoku-cell.vala"
				if (!_tmp6_) {
#line 2462 "sudoku-cell.c"
					gint _tmp7_;
#line 532 "../src/sudoku-cell.vala"
					_tmp7_ = num;
#line 532 "../src/sudoku-cell.vala"
					num = _tmp7_ + 1;
#line 2468 "sudoku-cell.c"
				}
#line 532 "../src/sudoku-cell.vala"
				_tmp6_ = FALSE;
#line 532 "../src/sudoku-cell.vala"
				_tmp8_ = marks;
#line 532 "../src/sudoku-cell.vala"
				_tmp8__length1 = marks_length1;
#line 532 "../src/sudoku-cell.vala"
				if (!(num <= _tmp8__length1)) {
#line 532 "../src/sudoku-cell.vala"
					break;
#line 2480 "sudoku-cell.c"
				}
#line 533 "../src/sudoku-cell.vala"
				_tmp9_ = self->priv->earmark_labels;
#line 533 "../src/sudoku-cell.vala"
				_tmp9__length1 = self->priv->earmark_labels_length1;
#line 533 "../src/sudoku-cell.vala"
				_tmp10_ = _tmp9_[num - 1];
#line 533 "../src/sudoku-cell.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp10_, "error");
#line 2490 "sudoku-cell.c"
			}
		}
	}
#line 528 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2496 "sudoku-cell.c"
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_ = NULL;
	GtkPopover* _tmp1_;
	gint zoomed_size = 0;
	SudokuView* _tmp2_;
	GtkLabel* _tmp3_;
	GtkRequisition min_size = {0};
	GtkLabel* _tmp4_;
	GtkRequisition _tmp5_ = {0};
	gint value_width = 0;
	gint value_height = 0;
	GtkRequisition _tmp6_;
	GtkRequisition _tmp7_;
	GtkAllocation value_allocation = {0};
	GtkAllocation _tmp8_ = {0};
	GtkLabel* _tmp9_;
	GtkAllocation _tmp10_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp11_;
	SudokuBoard* _tmp12_;
	SudokuBoard* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	SudokuGame* _tmp16_;
	SudokuBoard* _tmp17_;
	SudokuBoard* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint num = 0;
#line 536 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 540 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->popover;
#line 540 "../src/sudoku-cell.vala"
	_tmp0_ = _tmp1_;
#line 540 "../src/sudoku-cell.vala"
	if (_tmp0_ != NULL) {
#line 540 "../src/sudoku-cell.vala"
		gtk_popover_present (_tmp0_);
#line 2545 "sudoku-cell.c"
	}
#line 542 "../src/sudoku-cell.vala"
	_tmp2_ = self->priv->view;
#line 542 "../src/sudoku-cell.vala"
	zoomed_size = (gint) (height * _tmp2_->value_zoom_multiplier);
#line 543 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->value_label;
#line 543 "../src/sudoku-cell.vala"
	sudoku_cell_set_font_size (self, _tmp3_, zoomed_size);
#line 546 "../src/sudoku-cell.vala"
	_tmp4_ = self->priv->value_label;
#line 546 "../src/sudoku-cell.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) _tmp4_, &_tmp5_, NULL);
#line 546 "../src/sudoku-cell.vala"
	min_size = _tmp5_;
#line 549 "../src/sudoku-cell.vala"
	_tmp6_ = min_size;
#line 549 "../src/sudoku-cell.vala"
	value_width = MAX (width, _tmp6_.width);
#line 550 "../src/sudoku-cell.vala"
	_tmp7_ = min_size;
#line 550 "../src/sudoku-cell.vala"
	value_height = MAX (height, _tmp7_.height);
#line 552 "../src/sudoku-cell.vala"
	_tmp8_.x = 0;
#line 552 "../src/sudoku-cell.vala"
	_tmp8_.y = 0;
#line 552 "../src/sudoku-cell.vala"
	_tmp8_.width = value_width;
#line 552 "../src/sudoku-cell.vala"
	_tmp8_.height = value_height;
#line 552 "../src/sudoku-cell.vala"
	value_allocation = _tmp8_;
#line 553 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->value_label;
#line 553 "../src/sudoku-cell.vala"
	_tmp10_ = value_allocation;
#line 553 "../src/sudoku-cell.vala"
	gtk_widget_size_allocate ((GtkWidget*) _tmp9_, &_tmp10_, baseline);
#line 556 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->game;
#line 556 "../src/sudoku-cell.vala"
	_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 556 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_;
#line 556 "../src/sudoku-cell.vala"
	_tmp14_ = sudoku_board_get_block_cols (_tmp13_);
#line 556 "../src/sudoku-cell.vala"
	_tmp15_ = _tmp14_;
#line 556 "../src/sudoku-cell.vala"
	earmark_width = width / _tmp15_;
#line 557 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->game;
#line 557 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 557 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 557 "../src/sudoku-cell.vala"
	_tmp19_ = sudoku_board_get_block_rows (_tmp18_);
#line 557 "../src/sudoku-cell.vala"
	_tmp20_ = _tmp19_;
#line 557 "../src/sudoku-cell.vala"
	earmark_height = height / _tmp20_;
#line 559 "../src/sudoku-cell.vala"
	num = 0;
#line 2611 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 560 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 2616 "sudoku-cell.c"
		{
			gboolean _tmp21_ = FALSE;
#line 560 "../src/sudoku-cell.vala"
			_tmp21_ = TRUE;
#line 560 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2623 "sudoku-cell.c"
				SudokuGame* _tmp23_;
				SudokuBoard* _tmp24_;
				SudokuBoard* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
#line 560 "../src/sudoku-cell.vala"
				if (!_tmp21_) {
#line 2631 "sudoku-cell.c"
					gint _tmp22_;
#line 560 "../src/sudoku-cell.vala"
					_tmp22_ = row_tmp;
#line 560 "../src/sudoku-cell.vala"
					row_tmp = _tmp22_ + 1;
#line 2637 "sudoku-cell.c"
				}
#line 560 "../src/sudoku-cell.vala"
				_tmp21_ = FALSE;
#line 560 "../src/sudoku-cell.vala"
				_tmp23_ = self->priv->game;
#line 560 "../src/sudoku-cell.vala"
				_tmp24_ = sudoku_game_get_board (_tmp23_);
#line 560 "../src/sudoku-cell.vala"
				_tmp25_ = _tmp24_;
#line 560 "../src/sudoku-cell.vala"
				_tmp26_ = sudoku_board_get_block_rows (_tmp25_);
#line 560 "../src/sudoku-cell.vala"
				_tmp27_ = _tmp26_;
#line 560 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp27_)) {
#line 560 "../src/sudoku-cell.vala"
					break;
#line 2655 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 562 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 2661 "sudoku-cell.c"
					{
						gboolean _tmp28_ = FALSE;
#line 562 "../src/sudoku-cell.vala"
						_tmp28_ = TRUE;
#line 562 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 2668 "sudoku-cell.c"
							SudokuGame* _tmp30_;
							SudokuBoard* _tmp31_;
							SudokuBoard* _tmp32_;
							gint _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							GtkLabel** _tmp36_;
							gint _tmp36__length1;
							GtkLabel* _tmp37_;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							GtkLabel* _tmp39_;
							GtkRequisition _tmp40_ = {0};
							GtkRequisition _tmp41_;
							GtkRequisition _tmp42_;
							GtkAllocation earmark_allocation = {0};
							SudokuGame* _tmp43_;
							SudokuBoard* _tmp44_;
							SudokuBoard* _tmp45_;
							gint _tmp46_;
							gint _tmp47_;
							GtkAllocation _tmp48_ = {0};
							GtkLabel** _tmp49_;
							gint _tmp49__length1;
							GtkLabel* _tmp50_;
							GtkAllocation _tmp51_;
#line 562 "../src/sudoku-cell.vala"
							if (!_tmp28_) {
#line 2697 "sudoku-cell.c"
								gint _tmp29_;
#line 562 "../src/sudoku-cell.vala"
								_tmp29_ = col_tmp;
#line 562 "../src/sudoku-cell.vala"
								col_tmp = _tmp29_ + 1;
#line 2703 "sudoku-cell.c"
							}
#line 562 "../src/sudoku-cell.vala"
							_tmp28_ = FALSE;
#line 562 "../src/sudoku-cell.vala"
							_tmp30_ = self->priv->game;
#line 562 "../src/sudoku-cell.vala"
							_tmp31_ = sudoku_game_get_board (_tmp30_);
#line 562 "../src/sudoku-cell.vala"
							_tmp32_ = _tmp31_;
#line 562 "../src/sudoku-cell.vala"
							_tmp33_ = sudoku_board_get_block_cols (_tmp32_);
#line 562 "../src/sudoku-cell.vala"
							_tmp34_ = _tmp33_;
#line 562 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp34_)) {
#line 562 "../src/sudoku-cell.vala"
								break;
#line 2721 "sudoku-cell.c"
							}
#line 564 "../src/sudoku-cell.vala"
							_tmp35_ = num;
#line 564 "../src/sudoku-cell.vala"
							num = _tmp35_ + 1;
#line 566 "../src/sudoku-cell.vala"
							_tmp36_ = self->priv->earmark_labels;
#line 566 "../src/sudoku-cell.vala"
							_tmp36__length1 = self->priv->earmark_labels_length1;
#line 566 "../src/sudoku-cell.vala"
							_tmp37_ = _tmp36_[num - 1];
#line 566 "../src/sudoku-cell.vala"
							sudoku_cell_set_font_size (self, _tmp37_, height / 4);
#line 567 "../src/sudoku-cell.vala"
							_tmp38_ = self->priv->earmark_labels;
#line 567 "../src/sudoku-cell.vala"
							_tmp38__length1 = self->priv->earmark_labels_length1;
#line 567 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_[num - 1];
#line 567 "../src/sudoku-cell.vala"
							gtk_widget_get_preferred_size ((GtkWidget*) _tmp39_, &_tmp40_, NULL);
#line 567 "../src/sudoku-cell.vala"
							min_size = _tmp40_;
#line 568 "../src/sudoku-cell.vala"
							_tmp41_ = min_size;
#line 568 "../src/sudoku-cell.vala"
							earmark_width = MAX (earmark_width, _tmp41_.width);
#line 569 "../src/sudoku-cell.vala"
							_tmp42_ = min_size;
#line 569 "../src/sudoku-cell.vala"
							earmark_height = MAX (earmark_height, _tmp42_.height);
#line 571 "../src/sudoku-cell.vala"
							_tmp43_ = self->priv->game;
#line 571 "../src/sudoku-cell.vala"
							_tmp44_ = sudoku_game_get_board (_tmp43_);
#line 571 "../src/sudoku-cell.vala"
							_tmp45_ = _tmp44_;
#line 571 "../src/sudoku-cell.vala"
							_tmp46_ = sudoku_board_get_block_rows (_tmp45_);
#line 571 "../src/sudoku-cell.vala"
							_tmp47_ = _tmp46_;
#line 571 "../src/sudoku-cell.vala"
							_tmp48_.x = col_tmp * earmark_width;
#line 571 "../src/sudoku-cell.vala"
							_tmp48_.y = ((_tmp47_ - row_tmp) - 1) * earmark_height;
#line 571 "../src/sudoku-cell.vala"
							_tmp48_.width = earmark_width;
#line 571 "../src/sudoku-cell.vala"
							_tmp48_.height = earmark_height;
#line 571 "../src/sudoku-cell.vala"
							earmark_allocation = _tmp48_;
#line 574 "../src/sudoku-cell.vala"
							_tmp49_ = self->priv->earmark_labels;
#line 574 "../src/sudoku-cell.vala"
							_tmp49__length1 = self->priv->earmark_labels_length1;
#line 574 "../src/sudoku-cell.vala"
							_tmp50_ = _tmp49_[num - 1];
#line 574 "../src/sudoku-cell.vala"
							_tmp51_ = earmark_allocation;
#line 574 "../src/sudoku-cell.vala"
							gtk_widget_size_allocate ((GtkWidget*) _tmp50_, &_tmp51_, baseline);
#line 2783 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 581 "../src/sudoku-cell.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 2797 "sudoku-cell.c"
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel* label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
#line 579 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 579 "../src/sudoku-cell.vala"
	g_return_if_fail (label != NULL);
#line 581 "../src/sudoku-cell.vala"
	_tmp0_ = gtk_label_get_attributes (label);
#line 581 "../src/sudoku-cell.vala"
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
#line 581 "../src/sudoku-cell.vala"
	attr_list = _tmp1_;
#line 582 "../src/sudoku-cell.vala"
	_tmp2_ = attr_list;
#line 582 "../src/sudoku-cell.vala"
	if (_tmp2_ == NULL) {
#line 2826 "sudoku-cell.c"
		PangoAttrList* _tmp3_;
#line 583 "../src/sudoku-cell.vala"
		_tmp3_ = pango_attr_list_new ();
#line 583 "../src/sudoku-cell.vala"
		_pango_attr_list_unref0 (attr_list);
#line 583 "../src/sudoku-cell.vala"
		attr_list = _tmp3_;
#line 2834 "sudoku-cell.c"
	}
#line 585 "../src/sudoku-cell.vala"
	_tmp4_ = attr_list;
#line 585 "../src/sudoku-cell.vala"
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
#line 585 "../src/sudoku-cell.vala"
	pango_attr_list_change (_tmp4_, _tmp5_);
#line 589 "../src/sudoku-cell.vala"
	_tmp6_ = attr_list;
#line 589 "../src/sudoku-cell.vala"
	gtk_label_set_attributes (label, _tmp6_);
#line 579 "../src/sudoku-cell.vala"
	_pango_attr_list_unref0 (attr_list);
#line 2848 "sudoku-cell.c"
}

void
sudoku_cell_dismiss_popover (SudokuCell* self)
{
	GtkPopover* _tmp0_;
#line 592 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 594 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->popover;
#line 594 "../src/sudoku-cell.vala"
	if (_tmp0_ != NULL) {
#line 2861 "sudoku-cell.c"
		GtkPopover* _tmp1_;
		GtkPopover* _tmp2_;
#line 596 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->popover;
#line 596 "../src/sudoku-cell.vala"
		gtk_popover_popdown (_tmp1_);
#line 597 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->popover;
#line 597 "../src/sudoku-cell.vala"
		gtk_popover_set_child (_tmp2_, NULL);
#line 2872 "sudoku-cell.c"
	}
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
	GtkLabel** _tmp1_;
	gint _tmp1__length1;
	GtkPopover* _tmp4_ = NULL;
	GtkPopover* _tmp5_;
#line 601 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 603 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->value_label;
#line 603 "../src/sudoku-cell.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 604 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->earmark_labels;
#line 604 "../src/sudoku-cell.vala"
	_tmp1__length1 = self->priv->earmark_labels_length1;
#line 2895 "sudoku-cell.c"
	{
		GtkLabel** earmark_collection = NULL;
		gint earmark_collection_length1 = 0;
		gint _earmark_collection_size_ = 0;
		gint earmark_it = 0;
#line 604 "../src/sudoku-cell.vala"
		earmark_collection = _tmp1_;
#line 604 "../src/sudoku-cell.vala"
		earmark_collection_length1 = _tmp1__length1;
#line 604 "../src/sudoku-cell.vala"
		for (earmark_it = 0; earmark_it < earmark_collection_length1; earmark_it = earmark_it + 1) {
#line 2907 "sudoku-cell.c"
			GtkLabel* _tmp2_;
			GtkLabel* earmark = NULL;
#line 604 "../src/sudoku-cell.vala"
			_tmp2_ = _g_object_ref0 (earmark_collection[earmark_it]);
#line 604 "../src/sudoku-cell.vala"
			earmark = _tmp2_;
#line 2914 "sudoku-cell.c"
			{
				GtkLabel* _tmp3_;
#line 605 "../src/sudoku-cell.vala"
				_tmp3_ = earmark;
#line 605 "../src/sudoku-cell.vala"
				gtk_widget_unparent ((GtkWidget*) _tmp3_);
#line 604 "../src/sudoku-cell.vala"
				_g_object_unref0 (earmark);
#line 2923 "sudoku-cell.c"
			}
		}
	}
#line 606 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->popover;
#line 606 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp5_;
#line 606 "../src/sudoku-cell.vala"
	if (_tmp4_ != NULL) {
#line 606 "../src/sudoku-cell.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp4_);
#line 2935 "sudoku-cell.c"
	}
#line 607 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 2939 "sudoku-cell.c"
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 122 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 122 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 122 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 122 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 122 "../src/sudoku-cell.vala"
	result = sudoku_board_get (_tmp2_, self->priv->row, self->priv->col);
#line 122 "../src/sudoku-cell.vala"
	return result;
#line 2961 "sudoku-cell.c"
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
#line 123 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/sudoku-cell.vala"
	if (value == 0) {
#line 2972 "sudoku-cell.c"
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		SudokuBoard* _tmp2_;
#line 126 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->game;
#line 126 "../src/sudoku-cell.vala"
		_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 126 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp1_;
#line 126 "../src/sudoku-cell.vala"
		if (sudoku_board_get (_tmp2_, self->priv->row, self->priv->col) != 0) {
#line 2984 "sudoku-cell.c"
			SudokuGame* _tmp3_;
#line 127 "../src/sudoku-cell.vala"
			_tmp3_ = self->priv->game;
#line 127 "../src/sudoku-cell.vala"
			sudoku_game_remove (_tmp3_, self->priv->row, self->priv->col);
#line 2990 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp4_;
			SudokuBoard* _tmp5_;
			SudokuBoard* _tmp6_;
#line 128 "../src/sudoku-cell.vala"
			_tmp4_ = self->priv->game;
#line 128 "../src/sudoku-cell.vala"
			_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 128 "../src/sudoku-cell.vala"
			_tmp6_ = _tmp5_;
#line 128 "../src/sudoku-cell.vala"
			if (sudoku_board_has_earmarks (_tmp6_, self->priv->row, self->priv->col)) {
#line 3003 "sudoku-cell.c"
				SudokuGame* _tmp7_;
#line 129 "../src/sudoku-cell.vala"
				_tmp7_ = self->priv->game;
#line 129 "../src/sudoku-cell.vala"
				sudoku_game_disable_all_earmarks (_tmp7_, self->priv->row, self->priv->col);
#line 3009 "sudoku-cell.c"
			}
		}
	} else {
		SudokuGame* _tmp8_;
		SudokuBoard* _tmp9_;
		SudokuBoard* _tmp10_;
#line 131 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->game;
#line 131 "../src/sudoku-cell.vala"
		_tmp9_ = sudoku_game_get_board (_tmp8_);
#line 131 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_;
#line 131 "../src/sudoku-cell.vala"
		if (value != sudoku_board_get (_tmp10_, self->priv->row, self->priv->col)) {
#line 3024 "sudoku-cell.c"
			gboolean _tmp11_ = FALSE;
			SudokuView* _tmp12_;
#line 133 "../src/sudoku-cell.vala"
			_tmp12_ = self->priv->view;
#line 133 "../src/sudoku-cell.vala"
			if (_tmp12_->autoclean_earmarks) {
#line 3031 "sudoku-cell.c"
				SudokuGame* _tmp13_;
				GameMode _tmp14_;
				GameMode _tmp15_;
#line 133 "../src/sudoku-cell.vala"
				_tmp13_ = self->priv->game;
#line 133 "../src/sudoku-cell.vala"
				_tmp14_ = sudoku_game_get_mode (_tmp13_);
#line 133 "../src/sudoku-cell.vala"
				_tmp15_ = _tmp14_;
#line 133 "../src/sudoku-cell.vala"
				_tmp11_ = _tmp15_ == GAME_MODE_PLAY;
#line 3043 "sudoku-cell.c"
			} else {
#line 133 "../src/sudoku-cell.vala"
				_tmp11_ = FALSE;
#line 3047 "sudoku-cell.c"
			}
#line 133 "../src/sudoku-cell.vala"
			if (_tmp11_) {
#line 3051 "sudoku-cell.c"
				SudokuGame* _tmp16_;
#line 134 "../src/sudoku-cell.vala"
				_tmp16_ = self->priv->game;
#line 134 "../src/sudoku-cell.vala"
				sudoku_game_insert_and_disable_related_earmarks (_tmp16_, self->priv->row, self->priv->col, value);
#line 3057 "sudoku-cell.c"
			} else {
				SudokuGame* _tmp17_;
#line 136 "../src/sudoku-cell.vala"
				_tmp17_ = self->priv->game;
#line 136 "../src/sudoku-cell.vala"
				sudoku_game_insert (_tmp17_, self->priv->row, self->priv->col, value);
#line 3064 "sudoku-cell.c"
			}
		}
	}
#line 123 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
#line 3070 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 154 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 154 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 154 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/sudoku-cell.vala"
	result = sudoku_board_get_is_fixed (_tmp2_, self->priv->row, self->priv->col);
#line 154 "../src/sudoku-cell.vala"
	return result;
#line 3092 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
#line 159 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../src/sudoku-cell.vala"
	result = self->priv->_selected;
#line 159 "../src/sudoku-cell.vala"
	return result;
#line 3105 "sudoku-cell.c"
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
#line 160 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/sudoku-cell.vala"
	self->priv->_selected = value;
#line 163 "../src/sudoku-cell.vala"
	sudoku_cell_set_fixed_css (self, !value);
#line 164 "../src/sudoku-cell.vala"
	if (value) {
#line 165 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
#line 3122 "sudoku-cell.c"
	} else {
#line 167 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
#line 3126 "sudoku-cell.c"
	}
#line 160 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
#line 3130 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlight_coord (SudokuCell* self)
{
	gboolean result;
#line 173 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 173 "../src/sudoku-cell.vala"
	result = self->priv->_highlight_coord;
#line 173 "../src/sudoku-cell.vala"
	return result;
#line 3143 "sudoku-cell.c"
}

void
sudoku_cell_set_highlight_coord (SudokuCell* self,
                                 gboolean value)
{
#line 174 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/sudoku-cell.vala"
	self->priv->_highlight_coord = value;
#line 177 "../src/sudoku-cell.vala"
	if (value) {
#line 178 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-coord");
#line 3158 "sudoku-cell.c"
	} else {
#line 180 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-coord");
#line 3162 "sudoku-cell.c"
	}
#line 174 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY]);
#line 3166 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlight_number (SudokuCell* self)
{
	gboolean result;
#line 186 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../src/sudoku-cell.vala"
	result = self->priv->_highlight_number;
#line 186 "../src/sudoku-cell.vala"
	return result;
#line 3179 "sudoku-cell.c"
}

void
sudoku_cell_set_highlight_number (SudokuCell* self,
                                  gboolean value)
{
#line 187 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/sudoku-cell.vala"
	self->priv->_highlight_number = value;
#line 190 "../src/sudoku-cell.vala"
	sudoku_cell_set_fixed_css (self, !value);
#line 191 "../src/sudoku-cell.vala"
	if (value) {
#line 192 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-number");
#line 3196 "sudoku-cell.c"
	} else {
#line 194 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-number");
#line 3200 "sudoku-cell.c"
	}
#line 187 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY]);
#line 3204 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_paused (SudokuCell* self)
{
	gboolean result;
#line 200 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 200 "../src/sudoku-cell.vala"
	result = self->priv->_paused;
#line 200 "../src/sudoku-cell.vala"
	return result;
#line 3217 "sudoku-cell.c"
}

void
sudoku_cell_set_paused (SudokuCell* self,
                        gboolean value)
{
#line 201 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/sudoku-cell.vala"
	self->priv->_paused = value;
#line 204 "../src/sudoku-cell.vala"
	if (value) {
#line 205 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "paused");
#line 3232 "sudoku-cell.c"
	} else {
#line 207 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "paused");
#line 3236 "sudoku-cell.c"
	}
#line 201 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_PAUSED_PROPERTY]);
#line 3240 "sudoku-cell.c"
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/sudoku-cell.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
#line 24 "../src/sudoku-cell.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
#line 24 "../src/sudoku-cell.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY] = g_param_spec_boolean ("highlight-coord", "highlight-coord", "highlight-coord", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY] = g_param_spec_boolean ("highlight-number", "highlight-number", "highlight-number", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_PAUSED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 117 "../src/sudoku-cell.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
#line 3275 "sudoku-cell.c"
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
#line 24 "../src/sudoku-cell.vala"
	self->priv = sudoku_cell_get_instance_private (self);
#line 157 "../src/sudoku-cell.vala"
	self->priv->_selected = FALSE;
#line 171 "../src/sudoku-cell.vala"
	self->priv->_highlight_coord = FALSE;
#line 184 "../src/sudoku-cell.vala"
	self->priv->_highlight_number = FALSE;
#line 198 "../src/sudoku-cell.vala"
	self->priv->_paused = FALSE;
#line 3292 "sudoku-cell.c"
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
#line 24 "../src/sudoku-cell.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
#line 28 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 31 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 32 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 36 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->popover);
#line 37 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 38 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->popover_controller);
#line 39 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->earmark_picker);
#line 40 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_picker);
#line 42 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 43 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
#line 3323 "sudoku-cell.c"
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_int (value, sudoku_cell_get_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlight_coord (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlight_number (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_PAUSED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_paused (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3394 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3400 "sudoku-cell.c"
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, g_value_get_int (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlight_coord (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlight_number (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_PAUSED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_paused (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3444 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3450 "sudoku-cell.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

