/* sudoku-window.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014, 2020 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "libsudoku.h"
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>

#define SUDOKU_WINDOW_small_window_width 600
#define SUDOKU_WINDOW_smallest_possible_width 360
#define SUDOKU_WINDOW_margin_default_size 25
#define SUDOKU_WINDOW_margin_small_size 10
#define SUDOKU_WINDOW_margin_size_diff (SUDOKU_WINDOW_margin_default_size - SUDOKU_WINDOW_margin_small_size)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_WINDOW (sudoku_window_get_type ())
#define SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_WINDOW, SudokuWindow))
#define SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_WINDOW, SudokuWindowClass))
#define IS_SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_WINDOW))
#define IS_SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_WINDOW))
#define SUDOKU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_WINDOW, SudokuWindowClass))

typedef struct _SudokuWindow SudokuWindow;
typedef struct _SudokuWindowClass SudokuWindowClass;
typedef struct _SudokuWindowPrivate SudokuWindowPrivate;

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef enum  {
	SUDOKU_WINDOW_SCREEN_NONE,
	SUDOKU_WINDOW_SCREEN_PLAY,
	SUDOKU_WINDOW_SCREEN_CREATE,
	SUDOKU_WINDOW_SCREEN_MENU
} SudokuWindowScreen;

#define TYPE_SUDOKU_WINDOW_SCREEN (sudoku_window_screen_get_type ())
enum  {
	SUDOKU_WINDOW_0_PROPERTY,
	SUDOKU_WINDOW_SETTINGS_PROPERTY,
	SUDOKU_WINDOW_VIEW_PROPERTY,
	SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY,
	SUDOKU_WINDOW_SHOW_TIMER_PROPERTY,
	SUDOKU_WINDOW_NUM_PROPERTIES
};
static GParamSpec* sudoku_window_properties[SUDOKU_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_AdwBreakpointCondition_free0(var) ((var == NULL) ? NULL : (var = (_vala_AdwBreakpointCondition_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuWindow {
	AdwApplicationWindow parent_instance;
	SudokuWindowPrivate * priv;
};

struct _SudokuWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _SudokuWindowPrivate {
	AdwWindowTitle* windowtitle;
	AdwHeaderBar* headerbar;
	GtkBox* game_box;
	GtkBox* start_box;
	GtkButton* start_button;
	GtkCheckButton* custom_check;
	GtkCheckButton* easy_check;
	GtkCheckButton* medium_check;
	GtkCheckButton* hard_check;
	GtkCheckButton* very_hard_check;
	GtkMenuButton* main_menu;
	GtkToggleButton* earmark_mode_button;
	GtkButton* undo_button;
	GtkButton* redo_button;
	GtkButton* back_button;
	GtkButton* unfullscreen_button;
	GtkButton* play_custom_game_button;
	GtkButton* play_pause_button;
	GtkButton* toggle_fullscreen_button;
	GtkBox* clock_box;
	GtkLabel* clock_label;
	gboolean window_is_maximized;
	gboolean window_is_fullscreen;
	gint window_width;
	gint window_height;
	gint small_window_height;
	gint smallest_possible_height;
	gboolean window_width_is_small;
	gboolean window_height_is_small;
	AdwBreakpoint* small_window_breakpoint;
	AdwBreakpointCondition* small_window_condition;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerScroll* scroll_controller;
	GSettings* _settings;
	SudokuView* _view;
	SudokuWindowScreen _current_screen;
	gboolean _show_timer;
};

static gint SudokuWindow_private_offset;
static gpointer sudoku_window_parent_class = NULL;

VALA_EXTERN GType sudoku_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuWindow, g_object_unref)
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_window_screen_get_type (void) G_GNUC_CONST ;
static void _vala_AdwBreakpointCondition_free (AdwBreakpointCondition* self);
VALA_EXTERN SudokuWindow* sudoku_window_new (GSettings* settings);
VALA_EXTERN SudokuWindow* sudoku_window_construct (GType object_type,
                                       GSettings* settings);
static void sudoku_window_set_settings (SudokuWindow* self,
                                 GSettings* value);
static void sudoku_window_construct_window_parameters (SudokuWindow* self);
static AdwBreakpointCondition* _vala_AdwBreakpointCondition_copy (AdwBreakpointCondition* self);
static void sudoku_window_window_width_is_big_cb (SudokuWindow* self);
static void _sudoku_window_window_width_is_big_cb_adw_breakpoint_unapply (AdwBreakpoint* _sender,
                                                                   gpointer self);
static void sudoku_window_window_width_is_small_cb (SudokuWindow* self);
static void _sudoku_window_window_width_is_small_cb_adw_breakpoint_apply (AdwBreakpoint* _sender,
                                                                   gpointer self);
static void __lambda13_ (SudokuWindow* self);
static void ___lambda13__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda14_ (SudokuWindow* self);
static void ___lambda14__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda15_ (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_window_get_view (SudokuWindow* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda15__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sudoku_window_set_gamebox_width_margins (SudokuWindow* self,
                                              gint width);
static void sudoku_window_set_gamebox_height_margins (SudokuWindow* self,
                                               gint height);
static void sudoku_window_button_released_cb (SudokuWindow* self,
                                       GtkGestureClick* gesture,
                                       gint n_press,
                                       gdouble x,
                                       gdouble y);
static void _sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static void sudoku_window_button_pressed_cb (SudokuWindow* self,
                                      GtkGestureClick* gesture,
                                      gint n_press,
                                      gdouble x,
                                      gdouble y);
static void _sudoku_window_button_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_window_scroll_cb (SudokuWindow* self,
                                  GtkEventControllerScroll* event,
                                  gdouble dx,
                                  gdouble dy);
static gboolean _sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                      gdouble dx,
                                                                      gdouble dy,
                                                                      gpointer self);
static void sudoku_window_scroll_begin_cb (SudokuWindow* self,
                                    GtkEventControllerScroll* event);
static void _sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin (GtkEventControllerScroll* _sender,
                                                                              gpointer self);
static void sudoku_window_scroll_end_cb (SudokuWindow* self,
                                  GtkEventControllerScroll* event);
static void _sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                          gpointer self);
static void sudoku_window_long_press_cb (SudokuWindow* self,
                                  GtkGestureLongPress* gesture,
                                  gdouble x,
                                  gdouble y);
static void _sudoku_window_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self);
static gboolean sudoku_window_close_cb (SudokuWindow* self);
static gboolean _sudoku_window_close_cb_gtk_window_close_request (GtkWindow* _sender,
                                                           gpointer self);
VALA_EXTERN GSettings* sudoku_window_get_settings (SudokuWindow* self);
VALA_EXTERN void sudoku_window_set_show_timer (SudokuWindow* self,
                                   gboolean value);
static void sudoku_window_start_game_cb (SudokuWindow* self,
                                  GtkButton* btn);
static gboolean* _bool_dup (gboolean* self);
static void _sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
VALA_EXTERN SudokuWindowScreen sudoku_window_get_current_screen (SudokuWindow* self);
VALA_EXTERN gboolean sudoku_window_get_show_timer (SudokuWindow* self);
VALA_EXTERN void sudoku_window_will_start_game (SudokuWindow* self);
VALA_EXTERN void sudoku_window_start_game (SudokuWindow* self,
                               SudokuGame* game);
static void sudoku_window_tick_cb (SudokuWindow* self);
static void _sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                              gpointer self);
VALA_EXTERN void sudoku_window_show_game_view (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
static void sudoku_window_set_view (SudokuWindow* self,
                             SudokuView* value);
VALA_EXTERN void sudoku_window_show_menu_screen (SudokuWindow* self);
static void sudoku_window_set_current_screen (SudokuWindow* self,
                                       SudokuWindowScreen value);
VALA_EXTERN void sudoku_window_set_board_visible (SudokuWindow* self,
                                      gboolean visible);
VALA_EXTERN void sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                                    DifficultyCategory difficulty);
VALA_EXTERN gboolean sudoku_window_is_board_visible (SudokuWindow* self);
VALA_EXTERN void sudoku_window_board_completed (SudokuWindow* self);
VALA_EXTERN void sudoku_window_display_pause_button (SudokuWindow* self);
VALA_EXTERN void sudoku_view_dismiss_popovers (SudokuView* self);
static gdouble sudoku_window_normalize (SudokuWindow* self,
                                 gint val,
                                 gint min,
                                 gint max);
static void sudoku_window_real_size_allocate (GtkWidget* base,
                                       gint width,
                                       gint height,
                                       gint baseline);
static void sudoku_window_real_dispose (GObject* base);
static void sudoku_window_finalize (GObject * obj);
static GType sudoku_window_get_type_once (void);
static void _vala_sudoku_window_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_sudoku_window_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
sudoku_window_get_instance_private (SudokuWindow* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuWindow_private_offset);
}

static void
_vala_AdwBreakpointCondition_free (AdwBreakpointCondition* self)
{
#line 66 "../src/sudoku-window.vala"
	g_boxed_free (adw_breakpoint_condition_get_type (), self);
#line 312 "sudoku-window.c"
}

static AdwBreakpointCondition*
_vala_AdwBreakpointCondition_copy (AdwBreakpointCondition* self)
{
#line 89 "../src/sudoku-window.vala"
	return g_boxed_copy (adw_breakpoint_condition_get_type (), self);
#line 320 "sudoku-window.c"
}

static gpointer
__vala_AdwBreakpointCondition_copy0 (gpointer self)
{
#line 89 "../src/sudoku-window.vala"
	return self ? _vala_AdwBreakpointCondition_copy (self) : NULL;
#line 328 "sudoku-window.c"
}

static void
_sudoku_window_window_width_is_big_cb_adw_breakpoint_unapply (AdwBreakpoint* _sender,
                                                              gpointer self)
{
#line 90 "../src/sudoku-window.vala"
	sudoku_window_window_width_is_big_cb ((SudokuWindow*) self);
#line 337 "sudoku-window.c"
}

static void
_sudoku_window_window_width_is_small_cb_adw_breakpoint_apply (AdwBreakpoint* _sender,
                                                              gpointer self)
{
#line 91 "../src/sudoku-window.vala"
	sudoku_window_window_width_is_small_cb ((SudokuWindow*) self);
#line 346 "sudoku-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 92 "../src/sudoku-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 354 "sudoku-window.c"
}

static void
__lambda13_ (SudokuWindow* self)
{
#line 95 "../src/sudoku-window.vala"
	self->priv->window_is_maximized = !self->priv->window_is_maximized;
#line 362 "sudoku-window.c"
}

static void
___lambda13__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 94 "../src/sudoku-window.vala"
	__lambda13_ ((SudokuWindow*) self);
#line 372 "sudoku-window.c"
}

static void
__lambda14_ (SudokuWindow* self)
{
#line 99 "../src/sudoku-window.vala"
	self->priv->window_is_fullscreen = !self->priv->window_is_fullscreen;
#line 100 "../src/sudoku-window.vala"
	if (self->priv->window_is_fullscreen) {
#line 382 "sudoku-window.c"
		AdwHeaderBar* _tmp0_;
		GtkButton* _tmp1_;
		GtkButton* _tmp2_;
		GtkButton* _tmp3_;
#line 102 "../src/sudoku-window.vala"
		_tmp0_ = self->priv->headerbar;
#line 102 "../src/sudoku-window.vala"
		adw_header_bar_set_decoration_layout (_tmp0_, ":close");
#line 103 "../src/sudoku-window.vala"
		_tmp1_ = self->priv->toggle_fullscreen_button;
#line 103 "../src/sudoku-window.vala"
		gtk_button_set_icon_name (_tmp1_, "view-restore-symbolic");
#line 104 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->toggle_fullscreen_button;
#line 104 "../src/sudoku-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _ ("Leave Fullscreen"));
#line 105 "../src/sudoku-window.vala"
		_tmp3_ = self->priv->unfullscreen_button;
#line 105 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, TRUE);
#line 403 "sudoku-window.c"
	} else {
		AdwHeaderBar* _tmp4_;
		GtkButton* _tmp5_;
		GtkButton* _tmp6_;
		GtkButton* _tmp7_;
#line 109 "../src/sudoku-window.vala"
		_tmp4_ = self->priv->headerbar;
#line 109 "../src/sudoku-window.vala"
		adw_header_bar_set_decoration_layout (_tmp4_, NULL);
#line 110 "../src/sudoku-window.vala"
		_tmp5_ = self->priv->toggle_fullscreen_button;
#line 110 "../src/sudoku-window.vala"
		gtk_button_set_icon_name (_tmp5_, "view-fullscreen-symbolic");
#line 111 "../src/sudoku-window.vala"
		_tmp6_ = self->priv->toggle_fullscreen_button;
#line 111 "../src/sudoku-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _ ("Fullscreen"));
#line 112 "../src/sudoku-window.vala"
		_tmp7_ = self->priv->unfullscreen_button;
#line 112 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 113 "../src/sudoku-window.vala"
		if (self->priv->window_is_maximized) {
#line 115 "../src/sudoku-window.vala"
			gtk_window_maximize ((GtkWindow*) self);
#line 116 "../src/sudoku-window.vala"
			return;
#line 431 "sudoku-window.c"
		}
	}
}

static void
___lambda14__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 98 "../src/sudoku-window.vala"
	__lambda14_ ((SudokuWindow*) self);
#line 443 "sudoku-window.c"
}

static void
__lambda15_ (SudokuWindow* self)
{
	SudokuView* _tmp0_;
#line 122 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_view;
#line 122 "../src/sudoku-window.vala"
	if (_tmp0_ != NULL) {
#line 454 "sudoku-window.c"
		SudokuView* _tmp1_;
		GtkMenuButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 123 "../src/sudoku-window.vala"
		_tmp1_ = self->priv->_view;
#line 123 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->main_menu;
#line 123 "../src/sudoku-window.vala"
		_tmp3_ = gtk_menu_button_get_active (_tmp2_);
#line 123 "../src/sudoku-window.vala"
		_tmp4_ = _tmp3_;
#line 123 "../src/sudoku-window.vala"
		sudoku_view_set_has_selection (_tmp1_, !_tmp4_);
#line 469 "sudoku-window.c"
	}
}

static void
___lambda15__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 121 "../src/sudoku-window.vala"
	__lambda15_ ((SudokuWindow*) self);
#line 480 "sudoku-window.c"
}

static void
_sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self)
{
#line 137 "../src/sudoku-window.vala"
	sudoku_window_button_released_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 492 "sudoku-window.c"
}

static void
_sudoku_window_button_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 138 "../src/sudoku-window.vala"
	sudoku_window_button_pressed_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 504 "sudoku-window.c"
}

static gboolean
_sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                             gdouble dx,
                                                             gdouble dy,
                                                             gpointer self)
{
	gboolean result;
	result = sudoku_window_scroll_cb ((SudokuWindow*) self, _sender, dx, dy);
#line 142 "../src/sudoku-window.vala"
	return result;
#line 517 "sudoku-window.c"
}

static void
_sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin (GtkEventControllerScroll* _sender,
                                                                         gpointer self)
{
#line 143 "../src/sudoku-window.vala"
	sudoku_window_scroll_begin_cb ((SudokuWindow*) self, _sender);
#line 526 "sudoku-window.c"
}

static void
_sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                     gpointer self)
{
#line 144 "../src/sudoku-window.vala"
	sudoku_window_scroll_end_cb ((SudokuWindow*) self, _sender);
#line 535 "sudoku-window.c"
}

static void
_sudoku_window_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self)
{
#line 148 "../src/sudoku-window.vala"
	sudoku_window_long_press_cb ((SudokuWindow*) self, _sender, x, y);
#line 546 "sudoku-window.c"
}

static gboolean
_sudoku_window_close_cb_gtk_window_close_request (GtkWindow* _sender,
                                                  gpointer self)
{
	gboolean result;
	result = sudoku_window_close_cb ((SudokuWindow*) self);
#line 151 "../src/sudoku-window.vala"
	return result;
#line 557 "sudoku-window.c"
}

SudokuWindow*
sudoku_window_construct (GType object_type,
                         GSettings* settings)
{
	SudokuWindow * self = NULL;
	AdwBreakpointCondition* _tmp0_;
	AdwBreakpointCondition* _tmp1_;
	AdwBreakpointCondition* _tmp2_;
	AdwBreakpoint* _tmp3_;
	AdwBreakpoint* _tmp4_;
	AdwBreakpoint* _tmp5_;
	AdwBreakpoint* _tmp6_;
	AdwBreakpoint* _tmp7_;
	GtkMenuButton* _tmp8_;
	GtkGestureClick* _tmp9_;
	GtkGestureClick* _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkGestureClick* _tmp13_;
	GtkEventController* _tmp14_;
	GtkEventControllerScroll* _tmp15_;
	GtkEventControllerScroll* _tmp16_;
	GtkEventControllerScroll* _tmp17_;
	GtkEventControllerScroll* _tmp18_;
	GtkEventControllerScroll* _tmp19_;
	GtkEventController* _tmp20_;
	GtkGestureLongPress* _tmp21_;
	GtkGestureLongPress* _tmp22_;
	GtkGestureLongPress* _tmp23_;
	GtkEventController* _tmp24_;
#line 82 "../src/sudoku-window.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 82 "../src/sudoku-window.vala"
	self = (SudokuWindow*) g_object_new (object_type, NULL);
#line 84 "../src/sudoku-window.vala"
	sudoku_window_set_settings (self, settings);
#line 86 "../src/sudoku-window.vala"
	sudoku_window_construct_window_parameters (self);
#line 88 "../src/sudoku-window.vala"
	_tmp0_ = adw_breakpoint_condition_new_length (ADW_BREAKPOINT_CONDITION_MAX_WIDTH, (gdouble) SUDOKU_WINDOW_small_window_width, ADW_LENGTH_UNIT_PX);
#line 88 "../src/sudoku-window.vala"
	__vala_AdwBreakpointCondition_free0 (self->priv->small_window_condition);
#line 88 "../src/sudoku-window.vala"
	self->priv->small_window_condition = _tmp0_;
#line 89 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->small_window_condition;
#line 89 "../src/sudoku-window.vala"
	_tmp2_ = __vala_AdwBreakpointCondition_copy0 (_tmp1_);
#line 89 "../src/sudoku-window.vala"
	_tmp3_ = adw_breakpoint_new (_tmp2_);
#line 89 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->small_window_breakpoint);
#line 89 "../src/sudoku-window.vala"
	self->priv->small_window_breakpoint = _tmp3_;
#line 90 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->small_window_breakpoint;
#line 90 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp4_, "unapply", (GCallback) _sudoku_window_window_width_is_big_cb_adw_breakpoint_unapply, self, 0);
#line 91 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->small_window_breakpoint;
#line 91 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp5_, "apply", (GCallback) _sudoku_window_window_width_is_small_cb_adw_breakpoint_apply, self, 0);
#line 92 "../src/sudoku-window.vala"
	_tmp6_ = self->priv->small_window_breakpoint;
#line 92 "../src/sudoku-window.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 92 "../src/sudoku-window.vala"
	adw_application_window_add_breakpoint ((AdwApplicationWindow*) self, _tmp7_);
#line 94 "../src/sudoku-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::maximized", (GCallback) ___lambda13__g_object_notify, self, 0);
#line 98 "../src/sudoku-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::fullscreened", (GCallback) ___lambda14__g_object_notify, self, 0);
#line 121 "../src/sudoku-window.vala"
	_tmp8_ = self->priv->main_menu;
#line 121 "../src/sudoku-window.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify::active", (GCallback) ___lambda15__g_object_notify, self, 0);
#line 126 "../src/sudoku-window.vala"
	if (self->priv->window_is_fullscreen) {
#line 127 "../src/sudoku-window.vala"
		gtk_window_fullscreen ((GtkWindow*) self);
#line 640 "sudoku-window.c"
	} else {
#line 128 "../src/sudoku-window.vala"
		if (self->priv->window_is_maximized) {
#line 129 "../src/sudoku-window.vala"
			gtk_window_maximize ((GtkWindow*) self);
#line 646 "sudoku-window.c"
		} else {
#line 132 "../src/sudoku-window.vala"
			sudoku_window_set_gamebox_width_margins (self, self->priv->window_width);
#line 133 "../src/sudoku-window.vala"
			sudoku_window_set_gamebox_height_margins (self, self->priv->window_height);
#line 652 "sudoku-window.c"
		}
	}
#line 135 "../src/sudoku-window.vala"
	_tmp9_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 135 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 135 "../src/sudoku-window.vala"
	self->priv->button_controller = _tmp9_;
#line 136 "../src/sudoku-window.vala"
	_tmp10_ = self->priv->button_controller;
#line 136 "../src/sudoku-window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp10_, (guint) 0);
#line 137 "../src/sudoku-window.vala"
	_tmp11_ = self->priv->button_controller;
#line 137 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp11_, "released", (GCallback) _sudoku_window_button_released_cb_gtk_gesture_click_released, self, 0);
#line 138 "../src/sudoku-window.vala"
	_tmp12_ = self->priv->button_controller;
#line 138 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp12_, "pressed", (GCallback) _sudoku_window_button_pressed_cb_gtk_gesture_click_pressed, self, 0);
#line 139 "../src/sudoku-window.vala"
	_tmp13_ = self->priv->button_controller;
#line 139 "../src/sudoku-window.vala"
	_tmp14_ = _g_object_ref0 ((GtkEventController*) _tmp13_);
#line 139 "../src/sudoku-window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp14_);
#line 141 "../src/sudoku-window.vala"
	_tmp15_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 141 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 141 "../src/sudoku-window.vala"
	self->priv->scroll_controller = _tmp15_;
#line 142 "../src/sudoku-window.vala"
	_tmp16_ = self->priv->scroll_controller;
#line 142 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp16_, "scroll", (GCallback) _sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll, self, 0);
#line 143 "../src/sudoku-window.vala"
	_tmp17_ = self->priv->scroll_controller;
#line 143 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp17_, "scroll-begin", (GCallback) _sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin, self, 0);
#line 144 "../src/sudoku-window.vala"
	_tmp18_ = self->priv->scroll_controller;
#line 144 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp18_, "scroll-end", (GCallback) _sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end, self, 0);
#line 145 "../src/sudoku-window.vala"
	_tmp19_ = self->priv->scroll_controller;
#line 145 "../src/sudoku-window.vala"
	_tmp20_ = _g_object_ref0 ((GtkEventController*) _tmp19_);
#line 145 "../src/sudoku-window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp20_);
#line 147 "../src/sudoku-window.vala"
	_tmp21_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 147 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 147 "../src/sudoku-window.vala"
	self->priv->long_press_controller = _tmp21_;
#line 148 "../src/sudoku-window.vala"
	_tmp22_ = self->priv->long_press_controller;
#line 148 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp22_, "pressed", (GCallback) _sudoku_window_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 149 "../src/sudoku-window.vala"
	_tmp23_ = self->priv->long_press_controller;
#line 149 "../src/sudoku-window.vala"
	_tmp24_ = _g_object_ref0 ((GtkEventController*) _tmp23_);
#line 149 "../src/sudoku-window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp24_);
#line 151 "../src/sudoku-window.vala"
	g_signal_connect_object ((GtkWindow*) self, "close-request", (GCallback) _sudoku_window_close_cb_gtk_window_close_request, self, 0);
#line 82 "../src/sudoku-window.vala"
	return self;
#line 723 "sudoku-window.c"
}

SudokuWindow*
sudoku_window_new (GSettings* settings)
{
#line 82 "../src/sudoku-window.vala"
	return sudoku_window_construct (TYPE_SUDOKU_WINDOW, settings);
#line 731 "sudoku-window.c"
}

static void
sudoku_window_construct_window_parameters (SudokuWindow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	gint headerbar_natural_height = 0;
	AdwHeaderBar* _tmp5_;
	gint _tmp6_ = 0;
	GtkLabel* title_label = NULL;
	AdwWindowTitle* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* _tmp9_;
	GtkLabel* _tmp10_;
	GValue _tmp11_ = {0};
#line 182 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_settings;
#line 184 "../src/sudoku-window.vala"
	self->priv->window_width = g_settings_get_int (_tmp0_, "window-width");
#line 185 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->_settings;
#line 185 "../src/sudoku-window.vala"
	self->priv->window_height = g_settings_get_int (_tmp1_, "window-height");
#line 186 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->_settings;
#line 186 "../src/sudoku-window.vala"
	self->priv->window_is_maximized = g_settings_get_boolean (_tmp2_, "window-is-maximized");
#line 187 "../src/sudoku-window.vala"
	_tmp3_ = self->priv->_settings;
#line 187 "../src/sudoku-window.vala"
	self->priv->window_is_fullscreen = g_settings_get_boolean (_tmp3_, "window-is-fullscreen");
#line 188 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->_settings;
#line 188 "../src/sudoku-window.vala"
	sudoku_window_set_show_timer (self, g_settings_get_boolean (_tmp4_, "show-timer"));
#line 191 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->headerbar;
#line 191 "../src/sudoku-window.vala"
	gtk_widget_measure ((GtkWidget*) _tmp5_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp6_, NULL, NULL);
#line 191 "../src/sudoku-window.vala"
	headerbar_natural_height = _tmp6_;
#line 193 "../src/sudoku-window.vala"
	self->priv->small_window_height = SUDOKU_WINDOW_small_window_width + headerbar_natural_height;
#line 194 "../src/sudoku-window.vala"
	self->priv->smallest_possible_height = SUDOKU_WINDOW_smallest_possible_width + headerbar_natural_height;
#line 196 "../src/sudoku-window.vala"
	self->priv->window_width_is_small = self->priv->window_width <= SUDOKU_WINDOW_small_window_width;
#line 197 "../src/sudoku-window.vala"
	self->priv->window_height_is_small = self->priv->window_height <= self->priv->small_window_height;
#line 199 "../src/sudoku-window.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, SUDOKU_WINDOW_smallest_possible_width, self->priv->smallest_possible_height);
#line 200 "../src/sudoku-window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, self->priv->window_width, self->priv->window_height);
#line 202 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->windowtitle;
#line 202 "../src/sudoku-window.vala"
	_tmp8_ = gtk_widget_get_first_child ((GtkWidget*) _tmp7_);
#line 202 "../src/sudoku-window.vala"
	_tmp9_ = gtk_widget_get_first_child (_tmp8_);
#line 202 "../src/sudoku-window.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_label_get_type (), GtkLabel));
#line 202 "../src/sudoku-window.vala"
	title_label = _tmp10_;
#line 203 "../src/sudoku-window.vala"
	g_value_init (&_tmp11_, G_TYPE_BOOLEAN);
#line 203 "../src/sudoku-window.vala"
	g_value_set_boolean (&_tmp11_, FALSE);
#line 203 "../src/sudoku-window.vala"
	g_object_set_property ((GObject*) title_label, "ellipsize", &_tmp11_);
#line 203 "../src/sudoku-window.vala"
	G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
#line 182 "../src/sudoku-window.vala"
	_g_object_unref0 (title_label);
#line 811 "sudoku-window.c"
}

static gboolean
sudoku_window_close_cb (SudokuWindow* self)
{
	GSettings* _tmp0_;
	gint default_width = 0;
	gint default_height = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	gboolean result;
#line 206 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 209 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_settings;
#line 209 "../src/sudoku-window.vala"
	g_settings_delay (_tmp0_);
#line 212 "../src/sudoku-window.vala"
	gtk_window_get_default_size ((GtkWindow*) self, &_tmp1_, &_tmp2_);
#line 212 "../src/sudoku-window.vala"
	default_width = _tmp1_;
#line 212 "../src/sudoku-window.vala"
	default_height = _tmp2_;
#line 213 "../src/sudoku-window.vala"
	_tmp3_ = self->priv->_settings;
#line 213 "../src/sudoku-window.vala"
	g_settings_set_int (_tmp3_, "window-width", default_width);
#line 214 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->_settings;
#line 214 "../src/sudoku-window.vala"
	g_settings_set_int (_tmp4_, "window-height", default_height);
#line 215 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->_settings;
#line 215 "../src/sudoku-window.vala"
	g_settings_set_boolean (_tmp5_, "window-is-maximized", self->priv->window_is_maximized);
#line 216 "../src/sudoku-window.vala"
	_tmp6_ = self->priv->_settings;
#line 216 "../src/sudoku-window.vala"
	g_settings_set_boolean (_tmp6_, "window-is-fullscreen", self->priv->window_is_fullscreen);
#line 217 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->_settings;
#line 217 "../src/sudoku-window.vala"
	g_settings_apply (_tmp7_);
#line 218 "../src/sudoku-window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 218 "../src/sudoku-window.vala"
	return result;
#line 864 "sudoku-window.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 225 "../src/sudoku-window.vala"
	dup = g_new0 (gboolean, 1);
#line 225 "../src/sudoku-window.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 225 "../src/sudoku-window.vala"
	return dup;
#line 877 "sudoku-window.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 225 "../src/sudoku-window.vala"
	return self ? _bool_dup (self) : NULL;
#line 885 "sudoku-window.c"
}

static void
sudoku_window_start_game_cb (SudokuWindow* self,
                             GtkButton* btn)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 222 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 222 "../src/sudoku-window.vala"
	g_return_if_fail (btn != NULL);
#line 224 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->easy_check;
#line 224 "../src/sudoku-window.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 224 "../src/sudoku-window.vala"
	_tmp2_ = _tmp1_;
#line 224 "../src/sudoku-window.vala"
	if (_tmp2_) {
#line 907 "sudoku-window.c"
		GtkWidget* _tmp3_ = NULL;
		gboolean* _tmp4_ = NULL;
#line 225 "../src/sudoku-window.vala"
		_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 225 "../src/sudoku-window.vala"
		_tmp4_ = NULL;
#line 225 "../src/sudoku-window.vala"
		if (_tmp3_ != NULL) {
#line 916 "sudoku-window.c"
			gboolean _tmp5_;
			gboolean* _tmp6_;
#line 225 "../src/sudoku-window.vala"
			_tmp5_ = gtk_widget_activate_action (_tmp3_, "app.start-game", "i", 1, NULL);
#line 225 "../src/sudoku-window.vala"
			_tmp6_ = __bool_dup0 (&_tmp5_);
#line 225 "../src/sudoku-window.vala"
			_g_free0 (_tmp4_);
#line 225 "../src/sudoku-window.vala"
			_tmp4_ = _tmp6_;
#line 927 "sudoku-window.c"
		}
#line 224 "../src/sudoku-window.vala"
		_g_free0 (_tmp4_);
#line 931 "sudoku-window.c"
	} else {
		GtkCheckButton* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 226 "../src/sudoku-window.vala"
		_tmp7_ = self->priv->medium_check;
#line 226 "../src/sudoku-window.vala"
		_tmp8_ = gtk_check_button_get_active (_tmp7_);
#line 226 "../src/sudoku-window.vala"
		_tmp9_ = _tmp8_;
#line 226 "../src/sudoku-window.vala"
		if (_tmp9_) {
#line 944 "sudoku-window.c"
			GtkWidget* _tmp10_ = NULL;
			gboolean* _tmp11_ = NULL;
#line 227 "../src/sudoku-window.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 227 "../src/sudoku-window.vala"
			_tmp11_ = NULL;
#line 227 "../src/sudoku-window.vala"
			if (_tmp10_ != NULL) {
#line 953 "sudoku-window.c"
				gboolean _tmp12_;
				gboolean* _tmp13_;
#line 227 "../src/sudoku-window.vala"
				_tmp12_ = gtk_widget_activate_action (_tmp10_, "app.start-game", "i", 2, NULL);
#line 227 "../src/sudoku-window.vala"
				_tmp13_ = __bool_dup0 (&_tmp12_);
#line 227 "../src/sudoku-window.vala"
				_g_free0 (_tmp11_);
#line 227 "../src/sudoku-window.vala"
				_tmp11_ = _tmp13_;
#line 964 "sudoku-window.c"
			}
#line 226 "../src/sudoku-window.vala"
			_g_free0 (_tmp11_);
#line 968 "sudoku-window.c"
		} else {
			GtkCheckButton* _tmp14_;
			gboolean _tmp15_;
			gboolean _tmp16_;
#line 228 "../src/sudoku-window.vala"
			_tmp14_ = self->priv->hard_check;
#line 228 "../src/sudoku-window.vala"
			_tmp15_ = gtk_check_button_get_active (_tmp14_);
#line 228 "../src/sudoku-window.vala"
			_tmp16_ = _tmp15_;
#line 228 "../src/sudoku-window.vala"
			if (_tmp16_) {
#line 981 "sudoku-window.c"
				GtkWidget* _tmp17_ = NULL;
				gboolean* _tmp18_ = NULL;
#line 229 "../src/sudoku-window.vala"
				_tmp17_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 229 "../src/sudoku-window.vala"
				_tmp18_ = NULL;
#line 229 "../src/sudoku-window.vala"
				if (_tmp17_ != NULL) {
#line 990 "sudoku-window.c"
					gboolean _tmp19_;
					gboolean* _tmp20_;
#line 229 "../src/sudoku-window.vala"
					_tmp19_ = gtk_widget_activate_action (_tmp17_, "app.start-game", "i", 3, NULL);
#line 229 "../src/sudoku-window.vala"
					_tmp20_ = __bool_dup0 (&_tmp19_);
#line 229 "../src/sudoku-window.vala"
					_g_free0 (_tmp18_);
#line 229 "../src/sudoku-window.vala"
					_tmp18_ = _tmp20_;
#line 1001 "sudoku-window.c"
				}
#line 228 "../src/sudoku-window.vala"
				_g_free0 (_tmp18_);
#line 1005 "sudoku-window.c"
			} else {
				GtkCheckButton* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
#line 230 "../src/sudoku-window.vala"
				_tmp21_ = self->priv->very_hard_check;
#line 230 "../src/sudoku-window.vala"
				_tmp22_ = gtk_check_button_get_active (_tmp21_);
#line 230 "../src/sudoku-window.vala"
				_tmp23_ = _tmp22_;
#line 230 "../src/sudoku-window.vala"
				if (_tmp23_) {
#line 1018 "sudoku-window.c"
					GtkWidget* _tmp24_ = NULL;
					gboolean* _tmp25_ = NULL;
#line 231 "../src/sudoku-window.vala"
					_tmp24_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 231 "../src/sudoku-window.vala"
					_tmp25_ = NULL;
#line 231 "../src/sudoku-window.vala"
					if (_tmp24_ != NULL) {
#line 1027 "sudoku-window.c"
						gboolean _tmp26_;
						gboolean* _tmp27_;
#line 231 "../src/sudoku-window.vala"
						_tmp26_ = gtk_widget_activate_action (_tmp24_, "app.start-game", "i", 4, NULL);
#line 231 "../src/sudoku-window.vala"
						_tmp27_ = __bool_dup0 (&_tmp26_);
#line 231 "../src/sudoku-window.vala"
						_g_free0 (_tmp25_);
#line 231 "../src/sudoku-window.vala"
						_tmp25_ = _tmp27_;
#line 1038 "sudoku-window.c"
					}
#line 230 "../src/sudoku-window.vala"
					_g_free0 (_tmp25_);
#line 1042 "sudoku-window.c"
				} else {
					GtkCheckButton* _tmp28_;
					gboolean _tmp29_;
					gboolean _tmp30_;
#line 232 "../src/sudoku-window.vala"
					_tmp28_ = self->priv->custom_check;
#line 232 "../src/sudoku-window.vala"
					_tmp29_ = gtk_check_button_get_active (_tmp28_);
#line 232 "../src/sudoku-window.vala"
					_tmp30_ = _tmp29_;
#line 232 "../src/sudoku-window.vala"
					if (_tmp30_) {
#line 1055 "sudoku-window.c"
						GtkWidget* _tmp31_ = NULL;
						gboolean* _tmp32_ = NULL;
#line 233 "../src/sudoku-window.vala"
						_tmp31_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 233 "../src/sudoku-window.vala"
						_tmp32_ = NULL;
#line 233 "../src/sudoku-window.vala"
						if (_tmp31_ != NULL) {
#line 1064 "sudoku-window.c"
							gboolean _tmp33_;
							gboolean* _tmp34_;
#line 233 "../src/sudoku-window.vala"
							_tmp33_ = gtk_widget_activate_action (_tmp31_, "app.start-game", "i", 5, NULL);
#line 233 "../src/sudoku-window.vala"
							_tmp34_ = __bool_dup0 (&_tmp33_);
#line 233 "../src/sudoku-window.vala"
							_g_free0 (_tmp32_);
#line 233 "../src/sudoku-window.vala"
							_tmp32_ = _tmp34_;
#line 1075 "sudoku-window.c"
						}
#line 232 "../src/sudoku-window.vala"
						_g_free0 (_tmp32_);
#line 1079 "sudoku-window.c"
					}
				}
			}
		}
	}
}

static void
_sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 26 "../src/sudoku-window.vala"
	sudoku_window_start_game_cb ((SudokuWindow*) self, _sender);
#line 1093 "sudoku-window.c"
}

static void
sudoku_window_window_width_is_big_cb (SudokuWindow* self)
{
	SudokuWindowScreen _tmp0_;
#line 236 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/sudoku-window.vala"
	self->priv->window_width_is_small = FALSE;
#line 239 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_current_screen;
#line 239 "../src/sudoku-window.vala"
	if (_tmp0_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 1108 "sudoku-window.c"
		GtkBox* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GtkToggleButton* _tmp4_;
#line 241 "../src/sudoku-window.vala"
		_tmp1_ = self->priv->clock_box;
#line 241 "../src/sudoku-window.vala"
		_tmp2_ = sudoku_window_get_show_timer (self);
#line 241 "../src/sudoku-window.vala"
		_tmp3_ = _tmp2_;
#line 241 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp3_);
#line 242 "../src/sudoku-window.vala"
		_tmp4_ = self->priv->earmark_mode_button;
#line 242 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 1125 "sudoku-window.c"
	}
}

static void
sudoku_window_window_width_is_small_cb (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	SudokuWindowScreen _tmp1_;
#line 246 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/sudoku-window.vala"
	self->priv->window_width_is_small = TRUE;
#line 249 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->clock_box;
#line 249 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 250 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->_current_screen;
#line 250 "../src/sudoku-window.vala"
	if (_tmp1_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 1146 "sudoku-window.c"
		GtkToggleButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 251 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->earmark_mode_button;
#line 251 "../src/sudoku-window.vala"
		_tmp3_ = sudoku_window_get_show_timer (self);
#line 251 "../src/sudoku-window.vala"
		_tmp4_ = _tmp3_;
#line 251 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, !_tmp4_);
#line 1158 "sudoku-window.c"
	}
}

void
sudoku_window_will_start_game (SudokuWindow* self)
{
	GtkButton* _tmp0_;
#line 282 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->back_button;
#line 284 "../src/sudoku-window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 1172 "sudoku-window.c"
}

static void
_sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                         gpointer self)
{
#line 290 "../src/sudoku-window.vala"
	sudoku_window_tick_cb ((SudokuWindow*) self);
#line 1181 "sudoku-window.c"
}

void
sudoku_window_start_game (SudokuWindow* self,
                          SudokuGame* game)
{
	SudokuGame* _tmp0_;
	SudokuView* _tmp1_;
	GSettings* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	GtkBox* _tmp7_;
	SudokuView* _tmp8_;
	SudokuView* _tmp9_;
	GtkButton* _tmp10_;
#line 287 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/sudoku-window.vala"
	g_return_if_fail (game != NULL);
#line 289 "../src/sudoku-window.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 289 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->game);
#line 289 "../src/sudoku-window.vala"
	self->priv->game = _tmp0_;
#line 290 "../src/sudoku-window.vala"
	g_signal_connect_object (game, "tick", (GCallback) _sudoku_window_tick_cb_sudoku_game_tick, self, 0);
#line 291 "../src/sudoku-window.vala"
	sudoku_game_start_clock (game);
#line 293 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->_view;
#line 293 "../src/sudoku-window.vala"
	if (_tmp1_ != NULL) {
#line 1215 "sudoku-window.c"
		GtkBox* _tmp2_;
		SudokuView* _tmp3_;
#line 294 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->game_box;
#line 294 "../src/sudoku-window.vala"
		_tmp3_ = self->priv->_view;
#line 294 "../src/sudoku-window.vala"
		gtk_box_remove (_tmp2_, (GtkWidget*) _tmp3_);
#line 1224 "sudoku-window.c"
	}
#line 296 "../src/sudoku-window.vala"
	sudoku_window_show_game_view (self);
#line 298 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->_settings;
#line 298 "../src/sudoku-window.vala"
	_tmp5_ = sudoku_view_new (game, _tmp4_);
#line 298 "../src/sudoku-window.vala"
	g_object_ref_sink (_tmp5_);
#line 298 "../src/sudoku-window.vala"
	_tmp6_ = _tmp5_;
#line 298 "../src/sudoku-window.vala"
	sudoku_window_set_view (self, _tmp6_);
#line 298 "../src/sudoku-window.vala"
	_g_object_unref0 (_tmp6_);
#line 300 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->game_box;
#line 300 "../src/sudoku-window.vala"
	_tmp8_ = self->priv->_view;
#line 300 "../src/sudoku-window.vala"
	gtk_box_prepend (_tmp7_, (GtkWidget*) _tmp8_);
#line 301 "../src/sudoku-window.vala"
	_tmp9_ = self->priv->_view;
#line 301 "../src/sudoku-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 303 "../src/sudoku-window.vala"
	_tmp10_ = self->priv->back_button;
#line 303 "../src/sudoku-window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
#line 1254 "sudoku-window.c"
}

void
sudoku_window_show_menu_screen (SudokuWindow* self)
{
	AdwWindowTitle* _tmp0_;
	GtkButton* _tmp1_;
	SudokuGame* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkBox* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
#line 306 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 308 "../src/sudoku-window.vala"
	sudoku_window_set_current_screen (self, SUDOKU_WINDOW_SCREEN_MENU);
#line 309 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->windowtitle;
#line 309 "../src/sudoku-window.vala"
	adw_window_title_set_subtitle (_tmp0_, _ ("Select Difficulty"));
#line 310 "../src/sudoku-window.vala"
	sudoku_window_set_board_visible (self, FALSE);
#line 311 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->back_button;
#line 311 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->game;
#line 311 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp2_ != NULL);
#line 312 "../src/sudoku-window.vala"
	_tmp3_ = self->priv->earmark_mode_button;
#line 312 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 313 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->undo_button;
#line 313 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 314 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->redo_button;
#line 314 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 315 "../src/sudoku-window.vala"
	_tmp6_ = self->priv->clock_box;
#line 315 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, FALSE);
#line 316 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->play_pause_button;
#line 316 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 317 "../src/sudoku-window.vala"
	_tmp8_ = self->priv->start_button;
#line 317 "../src/sudoku-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 1309 "sudoku-window.c"
}

void
sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                               DifficultyCategory difficulty)
{
#line 320 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/sudoku-window.vala"
	switch (difficulty) {
#line 322 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 1322 "sudoku-window.c"
		{
			GtkCheckButton* _tmp0_;
#line 325 "../src/sudoku-window.vala"
			_tmp0_ = self->priv->easy_check;
#line 325 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp0_, "activate");
#line 326 "../src/sudoku-window.vala"
			return;
#line 1331 "sudoku-window.c"
		}
#line 322 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 1335 "sudoku-window.c"
		{
			GtkCheckButton* _tmp1_;
#line 328 "../src/sudoku-window.vala"
			_tmp1_ = self->priv->medium_check;
#line 328 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp1_, "activate");
#line 329 "../src/sudoku-window.vala"
			return;
#line 1344 "sudoku-window.c"
		}
#line 322 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 1348 "sudoku-window.c"
		{
			GtkCheckButton* _tmp2_;
#line 331 "../src/sudoku-window.vala"
			_tmp2_ = self->priv->hard_check;
#line 331 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp2_, "activate");
#line 332 "../src/sudoku-window.vala"
			return;
#line 1357 "sudoku-window.c"
		}
#line 322 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 1361 "sudoku-window.c"
		{
			GtkCheckButton* _tmp3_;
#line 334 "../src/sudoku-window.vala"
			_tmp3_ = self->priv->very_hard_check;
#line 334 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp3_, "activate");
#line 335 "../src/sudoku-window.vala"
			return;
#line 1370 "sudoku-window.c"
		}
#line 322 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 1374 "sudoku-window.c"
		{
			GtkCheckButton* _tmp4_;
#line 337 "../src/sudoku-window.vala"
			_tmp4_ = self->priv->custom_check;
#line 337 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp4_, "activate");
#line 338 "../src/sudoku-window.vala"
			return;
#line 1383 "sudoku-window.c"
		}
		default:
		{
#line 340 "../src/sudoku-window.vala"
			g_assert_not_reached ();
#line 1389 "sudoku-window.c"
		}
	}
}

void
sudoku_window_set_board_visible (SudokuWindow* self,
                                 gboolean visible)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkButton* _tmp6_;
#line 344 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 346 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->start_box;
#line 346 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, !visible);
#line 347 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->game_box;
#line 347 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, visible);
#line 348 "../src/sudoku-window.vala"
	if (visible) {
#line 1414 "sudoku-window.c"
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 348 "../src/sudoku-window.vala"
		_tmp3_ = self->priv->game;
#line 348 "../src/sudoku-window.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 348 "../src/sudoku-window.vala"
		_tmp5_ = _tmp4_;
#line 348 "../src/sudoku-window.vala"
		_tmp2_ = _tmp5_ == GAME_MODE_CREATE;
#line 1426 "sudoku-window.c"
	} else {
#line 348 "../src/sudoku-window.vala"
		_tmp2_ = FALSE;
#line 1430 "sudoku-window.c"
	}
#line 348 "../src/sudoku-window.vala"
	_tmp6_ = self->priv->play_custom_game_button;
#line 348 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp2_);
#line 1436 "sudoku-window.c"
}

gboolean
sudoku_window_is_board_visible (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 351 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 353 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game_box;
#line 353 "../src/sudoku-window.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 353 "../src/sudoku-window.vala"
	_tmp2_ = _tmp1_;
#line 353 "../src/sudoku-window.vala"
	result = _tmp2_;
#line 353 "../src/sudoku-window.vala"
	return result;
#line 1458 "sudoku-window.c"
}

void
sudoku_window_show_game_view (SudokuWindow* self)
{
	SudokuGame* _tmp0_;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	SudokuGame* _tmp7_;
	GameMode _tmp8_;
	GameMode _tmp9_;
#line 356 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game;
#line 356 "../src/sudoku-window.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "game != null");
#line 359 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->game;
#line 359 "../src/sudoku-window.vala"
	_tmp2_ = sudoku_game_get_mode (_tmp1_);
#line 359 "../src/sudoku-window.vala"
	_tmp3_ = _tmp2_;
#line 359 "../src/sudoku-window.vala"
	sudoku_window_set_current_screen (self, (SudokuWindowScreen) _tmp3_);
#line 360 "../src/sudoku-window.vala"
	sudoku_window_set_board_visible (self, TRUE);
#line 361 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->back_button;
#line 361 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 362 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->undo_button;
#line 362 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 363 "../src/sudoku-window.vala"
	_tmp6_ = self->priv->redo_button;
#line 363 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 365 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->game;
#line 365 "../src/sudoku-window.vala"
	_tmp8_ = sudoku_game_get_mode (_tmp7_);
#line 365 "../src/sudoku-window.vala"
	_tmp9_ = _tmp8_;
#line 365 "../src/sudoku-window.vala"
	if (_tmp9_ == GAME_MODE_PLAY) {
#line 1510 "sudoku-window.c"
		GtkButton* _tmp10_;
		GtkButton* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_;
		gboolean _tmp16_;
		GtkBox* _tmp17_;
		gboolean _tmp18_ = FALSE;
		GtkToggleButton* _tmp21_;
		AdwWindowTitle* _tmp22_;
		SudokuGame* _tmp23_;
		SudokuBoard* _tmp24_;
		SudokuBoard* _tmp25_;
		DifficultyCategory _tmp26_;
		DifficultyCategory _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 367 "../src/sudoku-window.vala"
		_tmp10_ = self->priv->play_custom_game_button;
#line 367 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 368 "../src/sudoku-window.vala"
		_tmp11_ = self->priv->play_pause_button;
#line 368 "../src/sudoku-window.vala"
		_tmp12_ = sudoku_window_get_show_timer (self);
#line 368 "../src/sudoku-window.vala"
		_tmp13_ = _tmp12_;
#line 368 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp11_, _tmp13_);
#line 369 "../src/sudoku-window.vala"
		_tmp15_ = sudoku_window_get_show_timer (self);
#line 369 "../src/sudoku-window.vala"
		_tmp16_ = _tmp15_;
#line 369 "../src/sudoku-window.vala"
		if (_tmp16_) {
#line 369 "../src/sudoku-window.vala"
			_tmp14_ = !self->priv->window_width_is_small;
#line 1549 "sudoku-window.c"
		} else {
#line 369 "../src/sudoku-window.vala"
			_tmp14_ = FALSE;
#line 1553 "sudoku-window.c"
		}
#line 369 "../src/sudoku-window.vala"
		_tmp17_ = self->priv->clock_box;
#line 369 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp17_, _tmp14_);
#line 370 "../src/sudoku-window.vala"
		if (!self->priv->window_width_is_small) {
#line 370 "../src/sudoku-window.vala"
			_tmp18_ = TRUE;
#line 1563 "sudoku-window.c"
		} else {
			gboolean _tmp19_;
			gboolean _tmp20_;
#line 370 "../src/sudoku-window.vala"
			_tmp19_ = sudoku_window_get_show_timer (self);
#line 370 "../src/sudoku-window.vala"
			_tmp20_ = _tmp19_;
#line 370 "../src/sudoku-window.vala"
			_tmp18_ = !_tmp20_;
#line 1573 "sudoku-window.c"
		}
#line 370 "../src/sudoku-window.vala"
		_tmp21_ = self->priv->earmark_mode_button;
#line 370 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp21_, _tmp18_);
#line 371 "../src/sudoku-window.vala"
		_tmp22_ = self->priv->windowtitle;
#line 371 "../src/sudoku-window.vala"
		_tmp23_ = self->priv->game;
#line 371 "../src/sudoku-window.vala"
		_tmp24_ = sudoku_game_get_board (_tmp23_);
#line 371 "../src/sudoku-window.vala"
		_tmp25_ = _tmp24_;
#line 371 "../src/sudoku-window.vala"
		_tmp26_ = sudoku_board_get_difficulty_category (_tmp25_);
#line 371 "../src/sudoku-window.vala"
		_tmp27_ = _tmp26_;
#line 371 "../src/sudoku-window.vala"
		_tmp28_ = difficulty_category_to_string (_tmp27_);
#line 371 "../src/sudoku-window.vala"
		_tmp29_ = _tmp28_;
#line 371 "../src/sudoku-window.vala"
		adw_window_title_set_subtitle (_tmp22_, _tmp29_);
#line 371 "../src/sudoku-window.vala"
		_g_free0 (_tmp29_);
#line 1599 "sudoku-window.c"
	} else {
		GtkToggleButton* _tmp30_;
		GtkBox* _tmp31_;
		GtkButton* _tmp32_;
		GtkButton* _tmp33_;
		AdwWindowTitle* _tmp34_;
#line 375 "../src/sudoku-window.vala"
		_tmp30_ = self->priv->earmark_mode_button;
#line 375 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp30_, FALSE);
#line 376 "../src/sudoku-window.vala"
		_tmp31_ = self->priv->clock_box;
#line 376 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
#line 377 "../src/sudoku-window.vala"
		_tmp32_ = self->priv->play_custom_game_button;
#line 377 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp32_, TRUE);
#line 378 "../src/sudoku-window.vala"
		_tmp33_ = self->priv->play_pause_button;
#line 378 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp33_, FALSE);
#line 379 "../src/sudoku-window.vala"
		_tmp34_ = self->priv->windowtitle;
#line 379 "../src/sudoku-window.vala"
		adw_window_title_set_subtitle (_tmp34_, _ ("Create Puzzle"));
#line 1626 "sudoku-window.c"
	}
}

void
sudoku_window_board_completed (SudokuWindow* self)
{
	GtkButton* _tmp0_;
#line 383 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 385 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->play_custom_game_button;
#line 385 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 1640 "sudoku-window.c"
}

void
sudoku_window_display_pause_button (SudokuWindow* self)
{
	GtkButton* _tmp0_;
	const gchar* _tmp1_ = NULL;
	SudokuGame* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkButton* _tmp5_;
	const gchar* _tmp6_ = NULL;
	SudokuGame* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GtkButton* _tmp10_;
#line 388 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 390 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->play_pause_button;
#line 390 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 391 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->game;
#line 391 "../src/sudoku-window.vala"
	_tmp3_ = sudoku_game_get_paused (_tmp2_);
#line 391 "../src/sudoku-window.vala"
	_tmp4_ = _tmp3_;
#line 391 "../src/sudoku-window.vala"
	if (_tmp4_) {
#line 391 "../src/sudoku-window.vala"
		_tmp1_ = "media-playback-start-symbolic";
#line 1673 "sudoku-window.c"
	} else {
#line 391 "../src/sudoku-window.vala"
		_tmp1_ = "media-playback-pause-symbolic";
#line 1677 "sudoku-window.c"
	}
#line 391 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->play_pause_button;
#line 391 "../src/sudoku-window.vala"
	gtk_button_set_icon_name (_tmp5_, _tmp1_);
#line 392 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->game;
#line 392 "../src/sudoku-window.vala"
	_tmp8_ = sudoku_game_get_paused (_tmp7_);
#line 392 "../src/sudoku-window.vala"
	_tmp9_ = _tmp8_;
#line 392 "../src/sudoku-window.vala"
	if (_tmp9_) {
#line 392 "../src/sudoku-window.vala"
		_tmp6_ = _ ("Play");
#line 1693 "sudoku-window.c"
	} else {
#line 392 "../src/sudoku-window.vala"
		_tmp6_ = _ ("Pause");
#line 1697 "sudoku-window.c"
	}
#line 392 "../src/sudoku-window.vala"
	_tmp10_ = self->priv->play_pause_button;
#line 392 "../src/sudoku-window.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _tmp6_);
#line 1703 "sudoku-window.c"
}

static void
sudoku_window_tick_cb (SudokuWindow* self)
{
	gint elapsed_time = 0;
	SudokuGame* _tmp0_;
	gint hours = 0;
	gint minutes = 0;
	gint seconds = 0;
#line 395 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game;
#line 397 "../src/sudoku-window.vala"
	elapsed_time = (gint) sudoku_game_get_total_time_played (_tmp0_);
#line 398 "../src/sudoku-window.vala"
	hours = elapsed_time / 3600;
#line 399 "../src/sudoku-window.vala"
	minutes = (elapsed_time - (hours * 3600)) / 60;
#line 400 "../src/sudoku-window.vala"
	seconds = (elapsed_time - (hours * 3600)) - (minutes * 60);
#line 401 "../src/sudoku-window.vala"
	if (hours > 0) {
#line 1728 "sudoku-window.c"
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 402 "../src/sudoku-window.vala"
		_tmp1_ = self->priv->clock_label;
#line 402 "../src/sudoku-window.vala"
		_tmp2_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d∶\xE2\x80\x8E%02d", hours, minutes, seconds);
#line 402 "../src/sudoku-window.vala"
		_tmp3_ = _tmp2_;
#line 402 "../src/sudoku-window.vala"
		gtk_label_set_text (_tmp1_, _tmp3_);
#line 402 "../src/sudoku-window.vala"
		_g_free0 (_tmp3_);
#line 1742 "sudoku-window.c"
	} else {
		GtkLabel* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 404 "../src/sudoku-window.vala"
		_tmp4_ = self->priv->clock_label;
#line 404 "../src/sudoku-window.vala"
		_tmp5_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d", minutes, seconds);
#line 404 "../src/sudoku-window.vala"
		_tmp6_ = _tmp5_;
#line 404 "../src/sudoku-window.vala"
		gtk_label_set_text (_tmp4_, _tmp6_);
#line 404 "../src/sudoku-window.vala"
		_g_free0 (_tmp6_);
#line 1757 "sudoku-window.c"
	}
}

static void
sudoku_window_button_released_cb (SudokuWindow* self,
                                  GtkGestureClick* gesture,
                                  gint n_press,
                                  gdouble x,
                                  gdouble y)
{
	gboolean _tmp0_ = FALSE;
	SudokuView* _tmp1_ = NULL;
	SudokuView* _tmp2_;
#line 407 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 407 "../src/sudoku-window.vala"
	g_return_if_fail (gesture != NULL);
#line 412 "../src/sudoku-window.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 413 "../src/sudoku-window.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 1779 "sudoku-window.c"
	} else {
#line 412 "../src/sudoku-window.vala"
		_tmp0_ = FALSE;
#line 1783 "sudoku-window.c"
	}
#line 412 "../src/sudoku-window.vala"
	if (_tmp0_) {
#line 414 "../src/sudoku-window.vala"
		return;
#line 1789 "sudoku-window.c"
	}
#line 416 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->_view;
#line 416 "../src/sudoku-window.vala"
	_tmp1_ = _tmp2_;
#line 416 "../src/sudoku-window.vala"
	if (_tmp1_ != NULL) {
#line 416 "../src/sudoku-window.vala"
		sudoku_view_dismiss_popovers (_tmp1_);
#line 1799 "sudoku-window.c"
	}
#line 417 "../src/sudoku-window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1803 "sudoku-window.c"
}

static void
sudoku_window_button_pressed_cb (SudokuWindow* self,
                                 GtkGestureClick* gesture,
                                 gint n_press,
                                 gdouble x,
                                 gdouble y)
{
#line 425 "../src/sudoku-window.vala"
	static const gint MOUSE_BACKWARD = 8;
#line 426 "../src/sudoku-window.vala"
	static const gint MOUSE_FORWARD = 9;
#line 1817 "sudoku-window.c"
	SudokuWindowScreen _tmp0_;
#line 420 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/sudoku-window.vala"
	g_return_if_fail (gesture != NULL);
#line 427 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_current_screen;
#line 427 "../src/sudoku-window.vala"
	if (_tmp0_ != SUDOKU_WINDOW_SCREEN_MENU) {
#line 1827 "sudoku-window.c"
		gboolean _tmp1_ = FALSE;
#line 429 "../src/sudoku-window.vala"
		if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) MOUSE_BACKWARD)) {
#line 1831 "sudoku-window.c"
			SudokuGame* _tmp2_;
#line 430 "../src/sudoku-window.vala"
			_tmp2_ = self->priv->game;
#line 430 "../src/sudoku-window.vala"
			_tmp1_ = !sudoku_game_is_undostack_null (_tmp2_);
#line 1837 "sudoku-window.c"
		} else {
#line 429 "../src/sudoku-window.vala"
			_tmp1_ = FALSE;
#line 1841 "sudoku-window.c"
		}
#line 429 "../src/sudoku-window.vala"
		if (_tmp1_) {
#line 1845 "sudoku-window.c"
			SudokuGame* _tmp3_;
#line 432 "../src/sudoku-window.vala"
			_tmp3_ = self->priv->game;
#line 432 "../src/sudoku-window.vala"
			sudoku_game_undo (_tmp3_);
#line 433 "../src/sudoku-window.vala"
			gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1853 "sudoku-window.c"
		} else {
			gboolean _tmp4_ = FALSE;
#line 435 "../src/sudoku-window.vala"
			if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) MOUSE_FORWARD)) {
#line 1858 "sudoku-window.c"
				SudokuGame* _tmp5_;
#line 436 "../src/sudoku-window.vala"
				_tmp5_ = self->priv->game;
#line 436 "../src/sudoku-window.vala"
				_tmp4_ = !sudoku_game_is_redostack_null (_tmp5_);
#line 1864 "sudoku-window.c"
			} else {
#line 435 "../src/sudoku-window.vala"
				_tmp4_ = FALSE;
#line 1868 "sudoku-window.c"
			}
#line 435 "../src/sudoku-window.vala"
			if (_tmp4_) {
#line 1872 "sudoku-window.c"
				SudokuGame* _tmp6_;
#line 438 "../src/sudoku-window.vala"
				_tmp6_ = self->priv->game;
#line 438 "../src/sudoku-window.vala"
				sudoku_game_redo (_tmp6_);
#line 439 "../src/sudoku-window.vala"
				gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1880 "sudoku-window.c"
			}
		}
	}
}

static void
sudoku_window_long_press_cb (SudokuWindow* self,
                             GtkGestureLongPress* gesture,
                             gdouble x,
                             gdouble y)
{
#line 444 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 444 "../src/sudoku-window.vala"
	g_return_if_fail (gesture != NULL);
#line 448 "../src/sudoku-window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1898 "sudoku-window.c"
}

static gboolean
sudoku_window_scroll_cb (SudokuWindow* self,
                         GtkEventControllerScroll* event,
                         gdouble dx,
                         gdouble dy)
{
	GdkModifierType state = 0U;
	gboolean result;
#line 451 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 451 "../src/sudoku-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 456 "../src/sudoku-window.vala"
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) event);
#line 457 "../src/sudoku-window.vala"
	if (state == GDK_CONTROL_MASK) {
#line 459 "../src/sudoku-window.vala"
		if (dy <= ((gdouble) -1)) {
#line 461 "../src/sudoku-window.vala"
			gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.zoom-in", NULL, NULL);
#line 462 "../src/sudoku-window.vala"
			result = GDK_EVENT_STOP;
#line 462 "../src/sudoku-window.vala"
			return result;
#line 1925 "sudoku-window.c"
		} else {
#line 464 "../src/sudoku-window.vala"
			if (dy >= ((gdouble) 1)) {
#line 466 "../src/sudoku-window.vala"
				gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.zoom-out", NULL, NULL);
#line 467 "../src/sudoku-window.vala"
				result = GDK_EVENT_STOP;
#line 467 "../src/sudoku-window.vala"
				return result;
#line 1935 "sudoku-window.c"
			}
		}
	}
#line 471 "../src/sudoku-window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 471 "../src/sudoku-window.vala"
	return result;
#line 1943 "sudoku-window.c"
}

static void
sudoku_window_scroll_begin_cb (SudokuWindow* self,
                               GtkEventControllerScroll* event)
{
	GdkModifierType state = 0U;
#line 474 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/sudoku-window.vala"
	g_return_if_fail (event != NULL);
#line 477 "../src/sudoku-window.vala"
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) event);
#line 478 "../src/sudoku-window.vala"
	if (state == GDK_CONTROL_MASK) {
#line 480 "../src/sudoku-window.vala"
		gtk_event_controller_scroll_set_flags (event, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL | GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
#line 1961 "sudoku-window.c"
	}
}

static void
sudoku_window_scroll_end_cb (SudokuWindow* self,
                             GtkEventControllerScroll* event)
{
#line 485 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 485 "../src/sudoku-window.vala"
	g_return_if_fail (event != NULL);
#line 487 "../src/sudoku-window.vala"
	gtk_event_controller_scroll_set_flags (event, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 1975 "sudoku-window.c"
}

static gdouble
sudoku_window_normalize (SudokuWindow* self,
                         gint val,
                         gint min,
                         gint max)
{
	gdouble result;
#line 490 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 492 "../src/sudoku-window.vala"
	CLAMP (val, min, max);
#line 493 "../src/sudoku-window.vala"
	result = (val - min) / ((gdouble) (max - min));
#line 493 "../src/sudoku-window.vala"
	return result;
#line 1993 "sudoku-window.c"
}

static void
sudoku_window_set_gamebox_width_margins (SudokuWindow* self,
                                         gint width)
{
	gdouble factor = 0.0;
	gint margin_size = 0;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 496 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 498 "../src/sudoku-window.vala"
	factor = sudoku_window_normalize (self, width, SUDOKU_WINDOW_smallest_possible_width, SUDOKU_WINDOW_small_window_width);
#line 499 "../src/sudoku-window.vala"
	margin_size = SUDOKU_WINDOW_margin_small_size + ((gint) (SUDOKU_WINDOW_margin_size_diff * factor));
#line 500 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game_box;
#line 500 "../src/sudoku-window.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp0_, margin_size);
#line 501 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->game_box;
#line 501 "../src/sudoku-window.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, margin_size);
#line 2018 "sudoku-window.c"
}

static void
sudoku_window_set_gamebox_height_margins (SudokuWindow* self,
                                          gint height)
{
	gdouble factor = 0.0;
	gint margin_size = 0;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 504 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/sudoku-window.vala"
	factor = sudoku_window_normalize (self, height, self->priv->smallest_possible_height, self->priv->small_window_height);
#line 507 "../src/sudoku-window.vala"
	margin_size = SUDOKU_WINDOW_margin_small_size + ((gint) (SUDOKU_WINDOW_margin_size_diff * factor));
#line 508 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game_box;
#line 508 "../src/sudoku-window.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, margin_size);
#line 509 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->game_box;
#line 509 "../src/sudoku-window.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, margin_size);
#line 2043 "sudoku-window.c"
}

static void
sudoku_window_real_size_allocate (GtkWidget* base,
                                  gint width,
                                  gint height,
                                  gint baseline)
{
	SudokuWindow * self;
	gboolean _tmp0_ = FALSE;
#line 512 "../src/sudoku-window.vala"
	self = (SudokuWindow*) base;
#line 514 "../src/sudoku-window.vala"
	if (self->priv->window_width != width) {
#line 514 "../src/sudoku-window.vala"
		_tmp0_ = TRUE;
#line 2060 "sudoku-window.c"
	} else {
#line 514 "../src/sudoku-window.vala"
		_tmp0_ = self->priv->window_height != height;
#line 2064 "sudoku-window.c"
	}
#line 514 "../src/sudoku-window.vala"
	if (_tmp0_) {
#line 2068 "sudoku-window.c"
		GtkRequisition min_size = {0};
		GtkRequisition _tmp1_ = {0};
		GtkRequisition _tmp2_;
		GtkRequisition _tmp3_;
#line 516 "../src/sudoku-window.vala"
		sudoku_window_set_gamebox_width_margins (self, width);
#line 517 "../src/sudoku-window.vala"
		sudoku_window_set_gamebox_height_margins (self, height);
#line 520 "../src/sudoku-window.vala"
		gtk_widget_get_preferred_size ((GtkWidget*) self, &_tmp1_, NULL);
#line 520 "../src/sudoku-window.vala"
		min_size = _tmp1_;
#line 521 "../src/sudoku-window.vala"
		_tmp2_ = min_size;
#line 521 "../src/sudoku-window.vala"
		width = MAX (_tmp2_.width, width);
#line 521 "../src/sudoku-window.vala"
		self->priv->window_width = width;
#line 522 "../src/sudoku-window.vala"
		_tmp3_ = min_size;
#line 522 "../src/sudoku-window.vala"
		height = MAX (_tmp3_.height, height);
#line 522 "../src/sudoku-window.vala"
		self->priv->window_height = height;
#line 2093 "sudoku-window.c"
	}
#line 525 "../src/sudoku-window.vala"
	GTK_WIDGET_CLASS (sudoku_window_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow), width, height, baseline);
#line 2097 "sudoku-window.c"
}

static void
sudoku_window_real_dispose (GObject* base)
{
	SudokuWindow * self;
#line 528 "../src/sudoku-window.vala"
	self = (SudokuWindow*) base;
#line 532 "../src/sudoku-window.vala"
	gtk_widget_dispose_template ((GtkWidget*) self, G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 533 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (sudoku_window_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow));
#line 2110 "sudoku-window.c"
}

GSettings*
sudoku_window_get_settings (SudokuWindow* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 78 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_settings;
#line 78 "../src/sudoku-window.vala"
	result = _tmp0_;
#line 78 "../src/sudoku-window.vala"
	return result;
#line 2126 "sudoku-window.c"
}

static void
sudoku_window_set_settings (SudokuWindow* self,
                            GSettings* value)
{
	GSettings* old_value;
#line 78 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/sudoku-window.vala"
	old_value = sudoku_window_get_settings (self);
#line 78 "../src/sudoku-window.vala"
	if (old_value != value) {
#line 2140 "sudoku-window.c"
		GSettings* _tmp0_;
#line 78 "../src/sudoku-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 78 "../src/sudoku-window.vala"
		_g_object_unref0 (self->priv->_settings);
#line 78 "../src/sudoku-window.vala"
		self->priv->_settings = _tmp0_;
#line 78 "../src/sudoku-window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SETTINGS_PROPERTY]);
#line 2150 "sudoku-window.c"
	}
}

SudokuView*
sudoku_window_get_view (SudokuWindow* self)
{
	SudokuView* result;
	SudokuView* _tmp0_;
#line 79 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_view;
#line 79 "../src/sudoku-window.vala"
	result = _tmp0_;
#line 79 "../src/sudoku-window.vala"
	return result;
#line 2167 "sudoku-window.c"
}

static void
sudoku_window_set_view (SudokuWindow* self,
                        SudokuView* value)
{
	SudokuView* old_value;
#line 79 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/sudoku-window.vala"
	old_value = sudoku_window_get_view (self);
#line 79 "../src/sudoku-window.vala"
	if (old_value != value) {
#line 2181 "sudoku-window.c"
		SudokuView* _tmp0_;
#line 79 "../src/sudoku-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 79 "../src/sudoku-window.vala"
		_g_object_unref0 (self->priv->_view);
#line 79 "../src/sudoku-window.vala"
		self->priv->_view = _tmp0_;
#line 79 "../src/sudoku-window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY]);
#line 2191 "sudoku-window.c"
	}
}

SudokuWindowScreen
sudoku_window_get_current_screen (SudokuWindow* self)
{
	SudokuWindowScreen result;
#line 80 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 80 "../src/sudoku-window.vala"
	result = self->priv->_current_screen;
#line 80 "../src/sudoku-window.vala"
	return result;
#line 2205 "sudoku-window.c"
}

static void
sudoku_window_set_current_screen (SudokuWindow* self,
                                  SudokuWindowScreen value)
{
	SudokuWindowScreen old_value;
#line 80 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/sudoku-window.vala"
	old_value = sudoku_window_get_current_screen (self);
#line 80 "../src/sudoku-window.vala"
	if (old_value != value) {
#line 80 "../src/sudoku-window.vala"
		self->priv->_current_screen = value;
#line 80 "../src/sudoku-window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY]);
#line 2223 "sudoku-window.c"
	}
}

gboolean
sudoku_window_get_show_timer (SudokuWindow* self)
{
	gboolean result;
#line 257 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 257 "../src/sudoku-window.vala"
	result = self->priv->_show_timer;
#line 257 "../src/sudoku-window.vala"
	return result;
#line 2237 "sudoku-window.c"
}

void
sudoku_window_set_show_timer (SudokuWindow* self,
                              gboolean value)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuWindowScreen _tmp6_;
#line 258 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 259 "../src/sudoku-window.vala"
	self->priv->_show_timer = value;
#line 261 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->game;
#line 261 "../src/sudoku-window.vala"
	if (_tmp1_ != NULL) {
#line 2255 "sudoku-window.c"
		SudokuGame* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 261 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->game;
#line 261 "../src/sudoku-window.vala"
		_tmp3_ = sudoku_game_get_paused (_tmp2_);
#line 261 "../src/sudoku-window.vala"
		_tmp4_ = _tmp3_;
#line 261 "../src/sudoku-window.vala"
		_tmp0_ = _tmp4_;
#line 2267 "sudoku-window.c"
	} else {
#line 261 "../src/sudoku-window.vala"
		_tmp0_ = FALSE;
#line 2271 "sudoku-window.c"
	}
#line 261 "../src/sudoku-window.vala"
	if (_tmp0_) {
#line 2275 "sudoku-window.c"
		SudokuGame* _tmp5_;
#line 262 "../src/sudoku-window.vala"
		_tmp5_ = self->priv->game;
#line 262 "../src/sudoku-window.vala"
		sudoku_game_set_paused (_tmp5_, FALSE);
#line 2281 "sudoku-window.c"
	}
#line 264 "../src/sudoku-window.vala"
	_tmp6_ = self->priv->_current_screen;
#line 264 "../src/sudoku-window.vala"
	if (_tmp6_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 2287 "sudoku-window.c"
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 266 "../src/sudoku-window.vala"
		_tmp7_ = sudoku_window_get_show_timer (self);
#line 266 "../src/sudoku-window.vala"
		_tmp8_ = _tmp7_;
#line 266 "../src/sudoku-window.vala"
		if (_tmp8_) {
#line 2296 "sudoku-window.c"
			GtkToggleButton* _tmp9_;
			GtkBox* _tmp10_;
#line 268 "../src/sudoku-window.vala"
			_tmp9_ = self->priv->earmark_mode_button;
#line 268 "../src/sudoku-window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, !self->priv->window_width_is_small);
#line 269 "../src/sudoku-window.vala"
			_tmp10_ = self->priv->clock_box;
#line 269 "../src/sudoku-window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp10_, !self->priv->window_width_is_small);
#line 270 "../src/sudoku-window.vala"
			sudoku_window_display_pause_button (self);
#line 2309 "sudoku-window.c"
		} else {
			GtkBox* _tmp11_;
			GtkToggleButton* _tmp12_;
			GtkButton* _tmp13_;
#line 274 "../src/sudoku-window.vala"
			_tmp11_ = self->priv->clock_box;
#line 274 "../src/sudoku-window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, FALSE);
#line 275 "../src/sudoku-window.vala"
			_tmp12_ = self->priv->earmark_mode_button;
#line 275 "../src/sudoku-window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp12_, TRUE);
#line 276 "../src/sudoku-window.vala"
			_tmp13_ = self->priv->play_pause_button;
#line 276 "../src/sudoku-window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 2326 "sudoku-window.c"
		}
	}
#line 258 "../src/sudoku-window.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY]);
#line 2331 "sudoku-window.c"
}

static void
sudoku_window_class_init (SudokuWindowClass * klass,
                          gpointer klass_data)
{
#line 26 "../src/sudoku-window.vala"
	sudoku_window_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-window.vala"
	g_type_class_adjust_private_offset (klass, &SudokuWindow_private_offset);
#line 26 "../src/sudoku-window.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_window_real_size_allocate;
#line 26 "../src/sudoku-window.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_window_real_dispose;
#line 26 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_window_get_property;
#line 26 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_window_set_property;
#line 26 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_window_finalize;
#line 26 "../src/sudoku-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SETTINGS_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_VIEW_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_SUDOKU_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY] = g_param_spec_enum ("current-screen", "current-screen", "current-screen", TYPE_SUDOKU_WINDOW_SCREEN, SUDOKU_WINDOW_SCREEN_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SHOW_TIMER_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY] = g_param_spec_boolean ("show-timer", "show-timer", "show-timer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/sudoku-window.ui");
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "windowtitle", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, windowtitle));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, headerbar));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, game_box));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_box));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, custom_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "easy_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, easy_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "medium_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, medium_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, hard_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "very_hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, very_hard_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_menu", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, main_menu));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "earmark_mode_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, earmark_mode_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "undo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, undo_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "redo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, redo_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, back_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unfullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, unfullscreen_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_custom_game_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_custom_game_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_pause_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_pause_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toggle_fullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, toggle_fullscreen_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_box));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_label", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_label));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "start_game_cb", G_CALLBACK(_sudoku_window_start_game_cb_gtk_button_clicked));
#line 156 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_n, GDK_CONTROL_MASK, "app.new-game", NULL, NULL);
#line 157 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_p, GDK_CONTROL_MASK, "app.print-current-board", NULL, NULL);
#line 158 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_p, GDK_NO_MODIFIER_MASK, "app.pause", NULL, NULL);
#line 159 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_r, GDK_CONTROL_MASK, "app.reset-board", NULL, NULL);
#line 160 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_u, GDK_NO_MODIFIER_MASK, "app.undo", NULL, NULL);
#line 161 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_z, GDK_CONTROL_MASK, "app.undo", NULL, NULL);
#line 162 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_r, GDK_NO_MODIFIER_MASK, "app.redo", NULL, NULL);
#line 163 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_z, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "app.redo", NULL, NULL);
#line 164 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_e, GDK_NO_MODIFIER_MASK, "app.earmark-mode", NULL, NULL);
#line 165 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_question, GDK_CONTROL_MASK, "app.shortcuts-window", NULL, NULL);
#line 166 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_comma, GDK_CONTROL_MASK, "app.preferences-dialog", NULL, NULL);
#line 167 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_f, GDK_NO_MODIFIER_MASK, "app.toggle-fullscreen", NULL, NULL);
#line 168 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_F11, GDK_NO_MODIFIER_MASK, "app.toggle-fullscreen", NULL, NULL);
#line 169 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_h, GDK_CONTROL_MASK, "app.highlighter", NULL, NULL);
#line 170 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_w, GDK_CONTROL_MASK, "app.show-warnings", NULL, NULL);
#line 171 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_0, GDK_CONTROL_MASK, "app.zoom-reset", NULL, NULL);
#line 172 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_0, GDK_CONTROL_MASK, "app.zoom-reset", NULL, NULL);
#line 173 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_plus, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 174 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_equal, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 175 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Add, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 176 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_ZoomIn, GDK_NO_MODIFIER_MASK, "app.zoom-in", NULL, NULL);
#line 177 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_minus, GDK_CONTROL_MASK, "app.zoom-out", NULL, NULL);
#line 178 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Subtract, GDK_CONTROL_MASK, "app.zoom-out", NULL, NULL);
#line 179 "../src/sudoku-window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_ZoomOut, GDK_NO_MODIFIER_MASK, "app.zoom-out", NULL, NULL);
#line 2454 "sudoku-window.c"
}

static void
sudoku_window_instance_init (SudokuWindow * self,
                             gpointer klass)
{
#line 26 "../src/sudoku-window.vala"
	self->priv = sudoku_window_get_instance_private (self);
#line 72 "../src/sudoku-window.vala"
	self->priv->game = NULL;
#line 79 "../src/sudoku-window.vala"
	self->priv->_view = NULL;
#line 80 "../src/sudoku-window.vala"
	self->priv->_current_screen = SUDOKU_WINDOW_SCREEN_NONE;
#line 26 "../src/sudoku-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2471 "sudoku-window.c"
}

static void
sudoku_window_finalize (GObject * obj)
{
	SudokuWindow * self;
#line 26 "../src/sudoku-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 65 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->small_window_breakpoint);
#line 66 "../src/sudoku-window.vala"
	__vala_AdwBreakpointCondition_free0 (self->priv->small_window_condition);
#line 72 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->game);
#line 74 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 75 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 76 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 78 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->_settings);
#line 79 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->_view);
#line 26 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (sudoku_window_parent_class)->finalize (obj);
#line 2498 "sudoku-window.c"
}

static GType
sudoku_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuWindow), 0, (GInstanceInitFunc) sudoku_window_instance_init, NULL };
	GType sudoku_window_type_id;
	sudoku_window_type_id = g_type_register_static (adw_application_window_get_type (), "SudokuWindow", &g_define_type_info, 0);
	SudokuWindow_private_offset = g_type_add_instance_private (sudoku_window_type_id, sizeof (SudokuWindowPrivate));
	return sudoku_window_type_id;
}

GType
sudoku_window_get_type (void)
{
	static volatile gsize sudoku_window_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_type_id__once)) {
		GType sudoku_window_type_id;
		sudoku_window_type_id = sudoku_window_get_type_once ();
		g_once_init_leave (&sudoku_window_type_id__once, sudoku_window_type_id);
	}
	return sudoku_window_type_id__once;
}

static void
_vala_sudoku_window_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 26 "../src/sudoku-window.vala"
	switch (property_id) {
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_SETTINGS_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		g_value_set_object (value, sudoku_window_get_settings (self));
#line 26 "../src/sudoku-window.vala"
		break;
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_VIEW_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		g_value_set_object (value, sudoku_window_get_view (self));
#line 26 "../src/sudoku-window.vala"
		break;
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		g_value_set_enum (value, sudoku_window_get_current_screen (self));
#line 26 "../src/sudoku-window.vala"
		break;
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		g_value_set_boolean (value, sudoku_window_get_show_timer (self));
#line 26 "../src/sudoku-window.vala"
		break;
#line 2557 "sudoku-window.c"
		default:
#line 26 "../src/sudoku-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-window.vala"
		break;
#line 2563 "sudoku-window.c"
	}
}

static void
_vala_sudoku_window_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 26 "../src/sudoku-window.vala"
	switch (property_id) {
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_SETTINGS_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		sudoku_window_set_settings (self, g_value_get_object (value));
#line 26 "../src/sudoku-window.vala"
		break;
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_VIEW_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		sudoku_window_set_view (self, g_value_get_object (value));
#line 26 "../src/sudoku-window.vala"
		break;
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		sudoku_window_set_current_screen (self, g_value_get_enum (value));
#line 26 "../src/sudoku-window.vala"
		break;
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		sudoku_window_set_show_timer (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-window.vala"
		break;
#line 2601 "sudoku-window.c"
		default:
#line 26 "../src/sudoku-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-window.vala"
		break;
#line 2607 "sudoku-window.c"
	}
}

static GType
sudoku_window_screen_get_type_once (void)
{
	static const GEnumValue values[] = {{SUDOKU_WINDOW_SCREEN_NONE, "SUDOKU_WINDOW_SCREEN_NONE", "none"}, {SUDOKU_WINDOW_SCREEN_PLAY, "SUDOKU_WINDOW_SCREEN_PLAY", "play"}, {SUDOKU_WINDOW_SCREEN_CREATE, "SUDOKU_WINDOW_SCREEN_CREATE", "create"}, {SUDOKU_WINDOW_SCREEN_MENU, "SUDOKU_WINDOW_SCREEN_MENU", "menu"}, {0, NULL, NULL}};
	GType sudoku_window_screen_type_id;
	sudoku_window_screen_type_id = g_enum_register_static ("SudokuWindowScreen", values);
	return sudoku_window_screen_type_id;
}

GType
sudoku_window_screen_get_type (void)
{
	static volatile gsize sudoku_window_screen_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_screen_type_id__once)) {
		GType sudoku_window_screen_type_id;
		sudoku_window_screen_type_id = sudoku_window_screen_get_type_once ();
		g_once_init_leave (&sudoku_window_screen_type_id__once, sudoku_window_screen_type_id);
	}
	return sudoku_window_screen_type_id__once;
}

